var sddl_not = '';
function DisplayCreateFolderModal() {
  jQuery('#create_shared_folder_waiting_content').attr("style", "display: block;");
  jQuery('#create_shared_folder_waiting_logo').attr("style", "display: block;");
}

function HideCreateFolderModal() {
  jQuery('#create_shared_folder_waiting_content').attr("style", "display: none;");
  jQuery('#create_shared_folder_waiting_logo').attr("style", "display: none;");
}

function CreateSharedFolderGetUserList() {
  var sharename = jQuery('#create_folder_name').val();
  var path = jQuery('#create_folder_location').html();
  return jQuery.ajax({
    url: "/api/i/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "user_alload",
      "token": UToken
    }),
    contentType: "application/json;charset=utf-8",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      var userlist = "";
      jQuery('#create_folder_showuser').html('');
      for (var i = 0; i < data.results.records.length; i++) {
        //alert(JSON.stringify(data[i]))
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.records[i].name + '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + data.results.records[i].type + '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="user_ro" id="user_ro' + i + '" value="' + data.results.records[i].name + '" onclick="share_ro_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="user_rw" id="user_rw' + i + '" value="' + data.results.records[i].name + '" onclick="share_rw_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="user_no" id="user_no' + i + '" value="' + data.results.records[i].name + '" onclick="share_no_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '</tr>';
        jQuery('#create_folder_showuser').append(userlist);
      }
      jQuery("#create_folder_showuser tr:even").addClass("tr_even");
      jQuery('#create_folder_showuser tr:odd').addClass("tr_odd");
      jQuery('#create_folder_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#create_folder_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#create_folder_showuser tr:even").addClass("tr_even");
        jQuery('#create_folder_showuser tr:odd').addClass("tr_odd");
      });
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function CreateSharedFolderGetGroupList() {
  return jQuery.ajax({
    url: "/api/i/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "group_alload",
      "token": UToken
    }),
    contentType: "application/json;charset=utf-8",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      var grouplist = "";
      for (var i = 0; i < data.results.records.length; i++) {
        grouplist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.records[i].name + '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + data.results.records[i].type + '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="group_ro" id="group_ro' + i + '" value="' + data.results.records[i].name + '" onclick="share_ro_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="group_rw" id="group_rw' + i + '" value="' + data.results.records[i].name + '" onclick="share_ro_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="group_no" id="group_no' + i + '" value="' + data.results.records[i].name + '" onclick="share_ro_check(' + "'" + i + "'" + ')" />' +
          '</span></td>' +
          '</tr>';
        jQuery('#create_folder_showgroup').append(grouplist);
      }
      jQuery("#create_folder_showgroup tr:even").addClass("tr_even");
      jQuery('#create_folder_showgroup tr:odd').addClass("tr_odd");
      jQuery('#create_folder_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#create_folder_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#create_folder_showgroup tr:even").addClass("tr_even");
        jQuery('#create_folder_showgroup tr:odd').addClass("tr_odd");
      });
      jQuery('#create_folder_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    }
  });
}

function isValidSharedFolderName(path, folder, oldfolder) {
  if (oldfolder === undefined)
    oldfolder = "";
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      cmd: "sharedfolder_check_name",
      token: UToken,
      params: {
        'path': path,
        'name': folder
      }
    }),
    success: function(data) {
      //alert(JSON.stringify(data));
      if (data.err == 0) {
        jQuery('#create_folder_name').attr('class', 'unas_input');
        jQuery("#checksharedfoldername_info").attr('class', '');
        jQuery("#checksharedfoldername_info").attr('title', '');
        jQuery("#shared_folder_createfolder_submit").attr("class", "unas_button_sub");
      } else {
        jQuery('#create_folder_name').attr('class', 'unas_input_error');
        jQuery("#checksharedfoldername_info").attr('class', "unas_icon_error");
        jQuery("#checksharedfoldername_info").attr('title', UNAS._(data.errmsg));
        jQuery("#shared_folder_createfolder_submit").attr("class", "unas_button_sub_disabled");
      }
    }
  });
}

function share_ro_check(num) {
  var c_sel = jQuery('#create_folder_account_type').val();
  if (jQuery('#' + c_sel + '_ro' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
  }
}

function share_rw_check(num) {
  var c_sel = jQuery('#create_folder_account_type').val();
  if (jQuery('#' + c_sel + '_rw' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
  }
}

function share_no_check(num) {
  var c_sel = jQuery('#create_folder_account_type').val();
  if (jQuery('#' + c_sel + '_no' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
  }
}

function submit_createSharedFolder() {
  var folder = jQuery('#create_folder_name').val();
  var path = jQuery('#create_folder_location').attr('devpath');
  var format = 0;
  if (jQuery("#shared_folder_createfolder_submit").attr("class") != "unas_button_sub_disabled") {
    if (jQuery('#create_folder_share').prop("checked") == true) {
      var dirtype = parseInt(jQuery('#create_folder_share').val());
      if (jQuery('#create_folder_sharedformat').prop("checked") == true) {
        format = 1;
      }
    }
    if (jQuery('#create_folder_leaf').prop("checked") == true) {
      var dirtype = parseInt(jQuery('#create_folder_leaf').val());

    }
    if (jQuery('#create_folder_public').prop("checked") == true)
      var sharetype = parseInt(jQuery('#create_folder_public').val());
    if (jQuery('#create_folder_perm').prop("checked") == true)
      var sharetype = parseInt(jQuery('#create_folder_perm').val());

    var user = {};
    if (!jQuery('input[name="create_folder_radio_permission"]').prop("checked")) {
      var user_check = {};
      var group_check = {};
      jQuery('input[name=' + 'user_ro]:checked').each(function() {
        // user += 'user:'+jQuery(this).val()+":ro,";
        user[jQuery(this).val()] = 4;
        user_check[jQuery(this).val()] = 4;
      });
      jQuery('input[name=' + 'user_rw]:checked').each(function() {
        // user += 'user:'+jQuery(this).val()+":rw,";
        user[jQuery(this).val()] = 2;
        user_check[jQuery(this).val()] = 2;
      });
      jQuery('input[name=' + 'user_no]:checked').each(function() {
        // user += 'user:'+jQuery(this).val()+":no,";
        user[jQuery(this).val()] = 0;
        user_check[jQuery(this).val()] = 0;
      });

      jQuery('input[name=' + 'group_ro]:checked').each(function() {
        // user += 'group:'+jQuery(this).val()+":ro,";
        user["@" + jQuery(this).val()] = 4;
        group_check["@" + jQuery(this).val()] = 4;
      });
      jQuery('input[name=' + 'group_rw]:checked').each(function() {
        // user += 'group:'+jQuery(this).val()+":rw,";
        user["@" + jQuery(this).val()] = 2;
        group_check["@" + jQuery(this).val()] = 2;
      });
      jQuery('input[name=' + 'group_no]:checked').each(function() {
        // user += 'group:'+jQuery(this).val()+":no,";
        user["@" + jQuery(this).val()] = 0;
        group_check["@" + jQuery(this).val()] = 0;
      });
      if (jQuery.isEmptyObject(user_check)) {
        //说明一个都没有选
        jQuery('input[name=' + 'user_no]').each(function() {
          user[jQuery(this).val()] = 99; //代表未选
        });
      }
      if (jQuery.isEmptyObject(group_check)) {
        //说明一个都没有选
        jQuery('input[name=' + 'group_no]').each(function() {
          user["@" + jQuery(this).val()] = 99; //代表未选
        });
      }
    }

    //if (jQuery("#create_folder_recycle_public").prop('checked') == true) {
    //	var recycle = 2;
    //}else {
    //	var recycle = jQuery("#create_folder_recycle_yes").prop('checked')? 1:0;
    //}
    var recycle = jQuery("#create_folder_recycle_yes").prop('checked') ? 1 : 0;

    jQuery('#create_shared_folder_waiting_content').attr("style", "display:block");
    jQuery('#create_shared_folder_waiting_logo').attr("style", "display:block");

    var new_sddl = 'O:S-1-22-1-0G:S-1-22-2-0D:PAI';
    jQuery('#jv-user-group-list tr').each(function(i, e) {
      var ck = jQuery(e).find('input[type=checkbox]');
      for (var j = 0; j < ck.length; j++) {
        var id = jQuery(ck[j]).closest('tr.trp').attr('id');
        var ace = jQuery(ck[j]).closest('tr.trp').attr('ace');
        if (ck[j].checked) {
          if (jQuery(ck[j]).val()) {
            new_sddl += (ace || '(A;OICI;' + jQuery(ck[j]).val() + ';;;' + id + ')');
          }else {
            if (jQuery(ck[j]).attr('name') == 'sddl_user_no') {
              new_sddl += '(D;OICI;0x001f01ff;;;' + id + ')';
            }else if (true) {
              new_sddl += ace;
            }
          }
        }
      }
    })

    var note = jQuery('#jv-editshareddescribe').val();

    var worm = jQuery('#jv-enableworm').prop('checked') ? 1 : 0;
    var graceperiod = 0;
    if (worm) {
      graceperiod = jQuery('#jv-gp-s').val() || 300;
    }

    var sendData = {
      "cmd": "sharedfolder_create",
      "token": UToken,
      "params": {
        "sharename": folder.trim(),
        "vg": vg,
        "lv": lv,
        "note" : note,
        "share": dirtype,
        "browseable": 1,
        "public": sharetype,
        "format": format,
        "users": user,
        "recycle": recycle,
        "sddl" : new_sddl,
        worm : worm,
        graceperiod : +graceperiod
      }
    }
    jQuery.ajax({
      url: "/apps/shared-folder/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.stringify(sendData),
      contentType: "application/json;charset=utf-8",
      success: function(data) {
        jQuery('#create_shared_folder_waiting_content').attr("style", "display:none");
        jQuery('#create_shared_folder_waiting_logo').attr("style", "display:none");
        var w = window.top.UNAS.GetWindow('CreateSharedFolderWindow');
        w.ProcessCreateSharedFolder();
        MUI.closeWindow(parent.document.getElementById('CreateSharedFolderWindow'));
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        jQuery('#create_shared_folder_waiting_content').attr("style", "display:none;");
        jQuery('#create_shared_folder_waiting_logo').attr("style", "display:none;");
      }
    });
  }
}
function editshare_ro_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (jQuery('#' + c_sel + '_ro' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

  } else {
  }
  updateSelectAllOP(t);
}

function editshare_rw_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_rw' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)
  } else {
  }
  updateSelectAllOP(t);
}

function editshare_no_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (jQuery('#' + c_sel + '_no' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)
  } else {
  }
  updateSelectAllOP(t);
}

function editshare_cu_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_cu' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

  } else {

  }
  updateSelectAllOP(t);
}

function editshare_all_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_all' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)

  }
  updateSelectAllOP(t);
}

function acl_line_create(ace) {
  var sid, name, type, perm, flags, sddltype
  perm = {
    'value': '0x00100000'
  }
  ace.details.forEach((item, i) => {
    switch (item.title) {
      case "Type":
        type = item.value;
        break
      case "Flags":
        flags = item.value;
        break
      case "Rights":
        perm = item;
        if (perm.value.indexOf('0x') == -1) {
          perm_hex = 0
          // Alphabet described rights
          for (var i = 0; i < perm.value.length / 2; i++) {
            sd = perm.value.substr(i * 2, 2)
            if (typeof(SddlAceRights2int[sd]) != 'undefined') {
              perm_hex = perm_hex | SddlAceRights2int[sd]
            }
          }
          perm.value = '0x00' + perm_hex.toString(16)
        }
        break
      case "AccountSid":
        sid = item.value;
        name = item.details;
        break
    }
  })
  return [sid, perm.value];
}

function getPermissionuserlist(sddl_cg) {
  jQuery.ajax({
    url: "/api/acl/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      cmd: "acl_initinfo",
      token: UToken,
      params: {
        nasuser: 1
      }
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      var info = sddl_info = data.results || {};
      sddl_info.sddl = (sddl_cg || sddl_info.sddl);
      var nasuser = info.nas.user || [];
      var nasgroup = info.nas.group || [];
      var group_map = sddl_info.map.group;
      var user_map = sddl_info.map.user;

      var user = {};
      var group = {};
      var sysuser = {};
      var sysgroup = {};

      var aces = {};
      oldsddl = sddl_info.sddl;
      var sddl = sddlParseAny(sddl_info.sddl);
      sddl.details.forEach((header_item, num) => {
        switch (header_item.value) {
          case 'O':
            // owner
            sid = header_item.details.value;
            jQuery("#jv-editacl_owner_val").attr('value', sid);
            break;
          case 'G':
            // group
            sid = header_item.details.value;
            jQuery("#jv-editacl_group_val").attr('value', sid);
            break
          case 'D':
            header_item.details.details.forEach((item, i) => {
              switch (item.title) {
                case "Flags":
                  flags = item.value;
                  SE_DACL_PROTECTED = false;
                  SE_DACL_AUTO_INHERITED = false;
                  item.details.forEach((dacl_flag, j) => {
                    if (dacl_flag["value"] == "AI") {
                      SE_DACL_AUTO_INHERITED = true;
                    } else
                    if (dacl_flag["value"] == "P") {
                      SE_DACL_PROTECTED = true;
                    }
                  })
                  if (SE_DACL_AUTO_INHERITED && !SE_DACL_PROTECTED) {
                    jQuery('#jv_editinherit')[0].checked = true;
                  }
                  break

                case "ACEs":
                  aces = item.details;
                  break;
              }
            })
            break;
          default:
        }
      })

      for (var v in info.user) {
        if (info.user.hasOwnProperty(v)) {
          if (nasuser.includes(info.user[v])) {
            user[v] = info.user[v];
          }else {
            sysuser[v] = info.user[v];
          }
        }
      }
      for (var v in info.group) {
        if (info.group.hasOwnProperty(v)) {
          if (nasgroup.includes(info.group[v])) {
            group[v] = info.group[v];
          }else {
            sysgroup[v] = info.group[v];
          }
        }
      }

      for (var y = 0; y < aces.length; y++) {
        for (var v in user) {
          if (user.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
        for (var v in group) {
          if (group.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
        for (var v in sysgroup) {
          if (sysgroup.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
      }

      sddl_not = '';
      for (var y = 0; y < aces.length; y++) {
        if (!aces[y]['not']) {
          sddl_not += aces[y].value
        }
      }

      function usersid2name_edit(arr, sid, map, sddluser) {
        var username = [];
        for (var c = 0; c < aces.length; c++){
          var acl = acl_line_create(aces[c]);
          var s_name = '';
          if (typeof(map[acl[0]]) !== "undefined") {
            s_name = map[acl[0]];
          } else if (typeof(sddluser[acl[0]]) != "undefined") {
            s_name = sddluser[acl[0]];
          }
          for (var v in arr) {
            if (arr.hasOwnProperty(v)) {
              var v_name = "";
              if (typeof(map[v]) !== "undefined") {
                v_name = map[v];
              } else if (typeof(sddluser[v]) != "undefined") {
                v_name = sddluser[v];
              }

              if (s_name == v_name) {
                username.push(v_name)
              }
            }
          }
        }
        var len = 0;
        for (var i = 0; i < username.length; i++) {
          if (username[i] == sid) {
            len ++;
            continue;
          }
        }

        return len;
      }

      var userlist = "";
      jQuery('#create_folder_showuser').html('');
      var i = 0,j = 0, k = 0;
      for (var v in user) {
        if (user.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(user, user[v], user_map, sddl_info.user);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line_create(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                stp = 'row_acl';
                cus = rights;
              }
            } else {
              if (user[v].toLowerCase() == 'admin') {
                // perm_type = 'rw';
                // perm = 'Read/Write';
                // stp = 'row_acl';
                // perm_deny = '';
              }else {
                perm_type = '';
              }
            }
          }
          userlist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + user[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" ' + (perm_type == "custom" ? "checked" : "") + ' type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_ro" id="sddl_user_ro' + i + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_rw" id="sddl_user_rw' + i + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_no" id="sddl_user_no' + i + '" value="" onclick="editshare_no_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#create_folder_showuser').append(userlist);
          i++;
        }
      }

      var grouplist = "";
      jQuery('#create_folder_showgroup').html('');
      for (var v in group) {
        if (group.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(group, group[v], group_map, sddl_info.group);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line_create(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }

                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {
              if (group[v] == 'Administrators') {
                // perm_type = 'rw';
                // perm = 'Read/Write';
                // stp = 'row_acl';
                // perm_deny = '';
              }else {
                perm_type = '';
              }
            }
          }
          grouplist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + group[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_ro" id="sddl_group_ro' + j + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_rw" id="sddl_group_rw' + j + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_no" id="sddl_group_no' + j + '" value="" onclick="editshare_no_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#create_folder_showgroup').append(grouplist);
          j++;
        }
      }

      jQuery('#create_folder_showsys').html('');
      for (var v in sysuser) {
        if (sysuser.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(sysuser, sysuser[v], user_map, sddl_info.user);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line_create(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {
              perm_type = '';
            }
          }
          syslist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + sysuser[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_ro" id="sddl_sys_ro' + k + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_sys'" + ",'" + k + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_rw" id="sddl_sys_rw' + k + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_sys'" + ",'" + k + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_no" id="sddl_sys_no' + k + '" value="" onclick="editshare_no_check(' + "'sddl_sys'" + ",'" + k + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#create_folder_showsys').append(syslist);
          k++;
        }
      }

      var sysgrouplist = "";
      jQuery('#create_folder_showsgp').html('');
      var m = 0;
      for (var v in sysgroup) {
        if (sysgroup.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(sysgroup, sysgroup[v], group_map, sddl_info.group);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line_create(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {
              perm_type = '';
            }
          }
          sysgrouplist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + sysgroup[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_ro" id="sddl_sgp_ro' + m + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_rw" id="sddl_sgp_rw' + m + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_no" id="sddl_sgp_no' + m + '" value="" onclick="editshare_no_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#create_folder_showsgp').append(sysgrouplist);
          m++;
        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    },
    complete: function() {
      HideCreateFolderModal();
    }
  });
}

function searchUserList() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  var unas_item = jQuery(t).closest('div.unas_items');
  var currentTable = unas_item.siblings('div.unas_table ').find('.unas_table_content');
  var select = unas_item.find('select.unas_select');
  var mode = select.val();
  var ids = [];
  currentTable.children().each(function(i, e) {
    ids.push(e.id);
  })
  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }
  jQuery('#' + that + ' tr').hide().filter(":contains('" + (t.value) + "')").show();
}

(function() {
  DisplayCreateFolderModal();
  getPermissionuserlist();
  jQuery('#jv-nav-title').children().each(function(i, e) {
    e.onclick = function(e) {
      var id = jQuery(e.currentTarget).attr('type');
      var s_id = jQuery(e.currentTarget).siblings().attr('type');
      jQuery(e.currentTarget).attr('class', 'unas_tab_sel');
      jQuery(e.currentTarget).siblings().attr('class', 'unas_tab');
      jQuery('#' + id).show();
      jQuery('#' + s_id).hide();
    }
  })

  jQuery('#create_folder_location').html(volumemountpoint);
  jQuery('#create_folder_location').attr('devpath', volumepath);

  jQuery('#create_folder_leaf').click(function() {
    jQuery('#create_folder_public').prop("disabled", true);
    jQuery('#create_folder_perm').prop("disabled", true);
    jQuery('#create_folder_sharedformat').prop("disabled", true);
    jQuery('#create_folder_account_type').prop("disabled", true);
    // jQuery('#create_folder_showuser').html('');
    // jQuery('#create_folder_showgroup').html('');
  });
  jQuery('#create_folder_share').click(function() {
    jQuery('#create_folder_public').prop("disabled", false);
    jQuery('#create_folder_perm').prop("disabled", false);
    jQuery('#create_folder_sharedformat').prop("disabled", false);
    jQuery('#create_folder_public').prop("checked", true);
    jQuery('#create_folder_account_type').prop("disabled", true);
    jQuery('#create_folder_account_type').find("option[value='user']").attr("selected", true);
    // jQuery('#create_folder_showuser').html('');
    // jQuery('#create_folder_showgroup').html('');
  });

  jQuery('#create_folder_public').click(function() {
    jQuery('#create_folder_account_type').prop("disabled", true);
    jQuery('#create_folder_account_type').find("option[value='user']").attr("selected", true);
    // jQuery('#create_folder_showuser').html('');
    // jQuery('#create_folder_showgroup').html('');
  });
  jQuery('#create_folder_perm').click(function() {
    // jQuery('#create_folder_showuser').html('');
    // jQuery('#create_folder_showgroup').html('');
    jQuery('#create_folder_account_type').val('user');
    jQuery('#create_folder_account_type').prop("disabled", false);
    jQuery('#create_folder_account_type').find("option[value='user']").attr("selected", true);
    jQuery('#create_folder_showuser').show();
    // CreateSharedFolderGetUserList().then(CreateSharedFolderGetGroupList).done(function() {
    //   HideCreateFolderModal();
    // });

  });
  jQuery('#create_folder_account_type').change(function() {
    var acc_type = jQuery(this).val();
    if (acc_type == "user") {
      jQuery('#create_folder_showuser').show();
      jQuery('#create_folder_showgroup').hide();
      jQuery('#create_folder_showsys').hide();
      jQuery('#create_folder_showsgp').hide();
      jQuery('#jv-create_folder-Sort').attr('mode', 'user');
    } else if (acc_type == "group") {
      jQuery('#create_folder_showuser').hide();
      jQuery('#create_folder_showgroup').show();
      jQuery('#create_folder_showsys').hide();
      jQuery('#create_folder_showsgp').hide();
      jQuery('#jv-create_folder-Sort').attr('mode', 'group');
    }else if(acc_type == "sys"){
      jQuery('#create_folder_showuser').hide();
      jQuery('#create_folder_showgroup').hide();
      jQuery('#create_folder_showsys').show();
      jQuery('#create_folder_showsgp').hide();
      jQuery('#jv-create_folder-Sort').attr('mode', 'sys');
    }else {
      jQuery('#create_folder_showuser').hide();
      jQuery('#create_folder_showgroup').hide();
      jQuery('#create_folder_showsys').hide();
      jQuery('#create_folder_showsgp').show();
      jQuery('#jv-create_folder-Sort').attr('mode', 'sgp');
    }
     changeMode(this, acc_type);
  });
  jQuery('#create_folder_name').keyup(function() {
    var folder = jQuery('#create_folder_name').val().trim();
    if (folder == "") {
      jQuery('#create_folder_name').attr('class', 'unas_input_error');
      jQuery("#checksharedfoldername_info").attr('class', "unas_icon_error");
      jQuery("#checksharedfoldername_info").attr('title', UNAS._("Folder name is empty"));
      jQuery("#shared_folder_createfolder_submit").attr("class", "unas_button_sub_disabled");
      return;
    }
    if (folder.indexOf("#") != -1) {
      jQuery('#create_folder_name').attr('class', 'unas_input_error');
      jQuery("#checksharedfoldername_info").attr('class', "unas_icon_error");
      jQuery("#checksharedfoldername_info").attr('title', UNAS._("Invalid folder name"));
      jQuery("#shared_folder_createfolder_submit").attr("class", "unas_button_sub_disabled");
      return;
    }
    var path = jQuery('#create_folder_location').html();
    isValidSharedFolderName(path, folder);
  });
  jQuery("#jv-user-group-list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  HideCreateFolderModal();

  jQuery('#jv-enableworm').on('click', function(){
    if (this.checked) {
      jQuery('#jv-gpsitem').show();
    }else {
      jQuery('#jv-gpsitem').hide();
    }
  })

})();
