var customprivilegeWin = window.top.UNAS.GetWindow('jv-customPrivilegeWindow');
var widData = customprivilegeWin.options;
var currentTarget_ace = widData.target;

var ace;
var unassddlinfo = {
  unasuser: {},
  unasusergroup: {},
  sysuser: {},
  sysusergroup: {}
}

function validateCheckbox(e) {
  var len = jQuery('#jv-usertypelistbox input[type=checkbox]:checked').length;
  if (len == 0) {
    e.checked = true;
  }
  jQuery("#jv_sddl_sharedfolder").html('');
  jQuery('#jv-usertypelistbox input[type=checkbox]:checked').each(function(i, e) {
    var icon = 'userslogo';
    for (var id in unassddlinfo[e.value]) {
      if (id.split("-")[4] == undefined) {
        icon = 'smbicon';
      } else {
        var type = +id.split("-")[4];
        if (e.value == 'sysuser') {
          icon = 'smbicon';
        } else if (e.value == 'unasusergroup') {
          icon = 'groupslogo';
        } else if (e.value == 'sysusergroup') {
          icon = 'sysgrouplogo';
        }
      }
      jQuery("#jv_sddl_sharedfolder").append('<li class="' + icon + '" type="' + type + '" value="' + unassddlinfo[e.value][id] + '" uid="' + id + '" title="' + id + '"><span>' + unassddlinfo[e.value][id] + "</span></li>");
    }
  })
}

function setsddllist() {
  var groups = sddl_info.group || {};
  var users = sddl_info.user || {};

  var nasuser = sddl_info.nas.user || [];
  var nasgroup = sddl_info.nas.group || [];

  for (var id in users) {
    var type = +id.split("-")[4];
    var cu = 'userslogo';
    if (nasuser.includes(usersid2name(id))) {
      unassddlinfo.unasuser[id] = users[id];
    } else {
      unassddlinfo.sysuser[id] = users[id];
      cu = 'smbicon';
    }

    jQuery("#jv_sddl_sharedfolder").append('<li class="' + cu + '" type="' + type + '" value="' + users[id] + '" uid="' + id + '" title="' + id + '"><span>' + users[id] + "</span></li>");
  }

  for (var id in groups) {
    var type = +id.split("-")[4];
    var cg = 'groupslogo';
    if (nasgroup.includes(groupsid2name(id))) {
      unassddlinfo.unasusergroup[id] = groups[id];
    } else {
      unassddlinfo.sysusergroup[id] = groups[id];
      cg = 'sysgrouplogo';
    }
    jQuery("#jv_sddl_sharedfolder").append('<li class="' + cg + '"  type="' + type + '" value="' + groups[id] + '" gid="' + id + '" title="' + id + '"><span>' + groups[id] + "</span></li>");
  }
}

function savesddlset() {

  var sddl_hex = jQuery('#jv-accessval').attr("hex");
  if (new_ace) {
    ace_parts = ["A", "", "0x00100000", "", "", "LG"];
  } else {
    ace_item = ace.attr("ace");
    ace_parts = ace_item.trim('()').split(';');
  }
  ace_parts[0] = jQuery('#u-file_explorer_sddl_type').val();
  if (isDir) {
    flags = jQuery('#u-file_explorer_sddl_flags').val();
    ace_parts[1] = flags;
  }
  ace_parts[2] = sddl_hex;
  principal_type = "User";
  sid = "";
  principal_info = jQuery('#jv-sddl_principal_val');
  if (principal_info.attr("uid")) {
    sid = principal_info.attr("uid");
  } else if (principal_info.attr("gid")) {
    sid = principal_info.attr("gid");
    // principal_type = "Group";
  } else {

  }
  var nasuser = sddl_info.nas.user || [];
  var nasgroup = sddl_info.nas.group || [];

  if (nasuser.includes(usersid2name(sid)) || user_map.hasOwnProperty(sid)) {
    principal_type = 'unasuser';
  } else if (users.hasOwnProperty(sid)) {
    principal_type = 'sysuser';
  }

  if (nasgroup.includes(groupsid2name(sid)) || group_map.hasOwnProperty(sid)) {
    principal_type = 'unasusergroup';
  } else if (groups.hasOwnProperty(sid)) {
    principal_type = 'sysusergroup';
  }

  if (SddlSids.hasOwnProperty(sid)) {
    principal_type = 'sysusergroup';
  }

  var txt = {
    unasuser: 'User',
    unasusergroup: 'User Group',
    sysuser: 'System User',
    sysusergroup: 'System User Group'
  }

  var inherited = false;
  if (typeof(flags) == "string" && flags.includes("ID")) {
    inherited = true;
  }

  ace_parts[5] = sid;
  username = principal_info.text().trim();
  ace_new = '(' + ace_parts.join(';') + ')';

  new_info = '<td  width="20%" align="left" class="u-file_acl_username" sid="' + sid + '" username="' + username + '"><span  class="unas_table_text">' + username + '</span></td>' +
    '<td  width="10%" align="left"><span class="unas_table_text">' + UNAS._(txt[principal_type]) + '</span></td>' +
    '<td  width="10%" align="left"><span class="u-file_acl_type unas_table_text" code="' + jQuery('#u-file_explorer_sddl_type').val() + '">' + UNAS._(jQuery('#u-file_explorer_sddl_type').val() == 'A' ? "Allow" : "Deny") + '</span></td>';

  if (typeof(SddlWinPermission[sddl_hex]) !== 'undefined') {
    new_info += '<td  width="20%" align="left"><span class="unas_table_text">' + UNAS._(SddlWinPermission[sddl_hex]) + '<span></td>'
  } else {
    new_info += '<td  width="20%" align="left"><span class="unas_table_text">' + UNAS._('Customized') + '</span></td>'
  }
  if (isDir) {
    if (flags) {
      new_info += '<td width="25%" align="left" class="u-file_acl_flags" flags="' + flags + '"><span class="unas_table_text">' + UNAS._(SddlWindowsApplyTo[flags]) + '</span></td>'
    } else {
      new_info += '<td width="25%" align="left" class="u-file_acl_flags" flags=""><span class="unas_table_text">' + UNAS._(SddlWindowsApplyTo['0']) + '</span></td>'
    }
  }

  new_info += '<td width="15%" align="left"><span class="unas_table_text">' +
    '<a class="editfile" onclick="aceEdit(this)" ></a>' +
    '<a class="deletefile" onclick="btnDeleteAcl(this)"></a>' +
    '</span></td>'

  if (new_ace) {
    new_ace_item = '<tr class="trp" perm="' + sddl_hex + '" ace="' + ace_new + '" onmouseover="jQuery(this).addClass(\'on\')" onmouseout="jQuery(this).removeClass(\'on\')" class="" type="' + principal_type + '" inherited=' + inherited + '>' +
      new_info + '</tr>'
    jQuery('#u-file_explorer_acl_list').append(new_ace_item);
  } else {
    ace.attr("perm", sddl_hex);
    ace.attr("ace", ace_new);
    ace.html(new_info);
  }

  MUI.closeWindow($('jv-customPrivilegeWindow'));

}

function sddl_check(perm_check) {
  var perm = parseInt(jQuery(perm_check).attr("hex"), 16);
  var sddl_hex = parseInt(jQuery('#jv-accessval').attr("hex"), 16);
  if (jQuery(perm_check).prop("checked")) {
    sddl_hex = sddl_hex | perm;
  } else {
    sddl_hex -= sddl_hex & perm & 0xfffff;
  }
  jQuery('#jv-accessval').attr("hex", "0x00" + sddl_hex.toString(16));
  jQuery('.u-file_perm_detail_check').each(function(i, e) {
    var check_dom = jQuery(e);
    if ((check_dom.attr("hex") & sddl_hex) == check_dom.attr("hex")) {
      check_dom.prop("checked", true);
    } else {
      check_dom.prop("checked", false);
    }
  })
}


function setace(t) {
  ace = jQuery(t).closest('tr.trp');
  var sddl_hex = ace.attr("perm");
  jQuery('#jv-accessval').attr('hex', sddl_hex);
  var sid = ace.find('.u-file_acl_username').attr('sid');
  if (ace.find('.u-file_acl_username').attr('username') == ace.find('.u-file_acl_username').attr('sid')) {
    // Name not mapped. It's a sid
    jQuery("#u-file_explorer_sddl_principal").append('<li value="' + sid + '" uid="' + sid + '">' + sid + "</li>");
  }
  jQuery('#jv-sddl_principal_val').text(ace.find('.u-file_acl_username').attr('username')).attr('uid', sid);
  jQuery('#jv-sddl_principal_val').attr('uid', sid);

  jQuery('#u-file_explorer_sddl_type').val(ace.find('.u-file_acl_type').attr('code'));

  if (isDir) {
    flags = ace.find('.u-file_acl_flags').attr('flags');
    if (flags.substr(-2, 2) == "ID") {
      flags = flags.substr(0, flags.length - 2)
    }
    jQuery('#u-file_explorer_sddl_flags').val(flags);
  }
  // Init permission sddl

  jQuery('.u-file_perm_detail_check').each(function(i, e) {
    var check_dom = jQuery(e);
    if ((check_dom.attr("hex") & sddl_hex) == check_dom.attr("hex")) {
      check_dom.prop("checked", true);
    }
  })
}

function acl_check_access(user) {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  data = {
    cmd: "acl_check_access",
    token: UToken,
    params: {
      "path": path,
      "user": user
    }
  }
  jQuery.ajax({
    url: "/api/acl/index.php",
    type: "POST",
    async: true,
    timeout: 20000,
    dataType: "json",
    contentType: "json",
    data: JSON.encode(data),
    success: function(res) {
      if (res.results) {
        var info = res.results || {};
        var sddl_hex = info.A;
        var sddl_hex_d = info.D;
        jQuery('#jv-accessval').attr("hex", sddl_hex);
        jQuery('.u-file_perm_detail_check').each(function(i, e) {
          var check_dom = jQuery(e);
          if ((check_dom.attr("hex") & sddl_hex) == check_dom.attr("hex")) {
            check_dom.prop("checked", true);
          } else {
            check_dom.prop("checked", false);
          }
        })

        if (sddl_hex_d) {
          jQuery('.u-file_perm_detail_check').each(function(i, e) {
            var check_dom = jQuery(e);
            if ((check_dom.attr("hex") & sddl_hex_d) == check_dom.attr("hex")) {
              check_dom.prop("checked", true);
            } else {
              check_dom.prop("checked", false);
            }
          })
        }

        jQuery('#jv-sddl_principal_val').text(user);
      } else {
        jQuery('.u-file_perm_detail_check').prop("checked", false);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus, fm);
    }
  });
}
