//sort
function sortList() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  var tableHead = jQuery(t).closest('table.unas_table_title');
  // var tableContent = tableHead.siblings('.unas_table_content');

  var tableContent = tableHead.parents('.unas_table').find('.unas_table_content');
  var mode = tableHead.attr('mode');

  var unas_table = jQuery(t).closest('div.unas_table');
  var p_node = unas_table.siblings('.unas_items');
  var public = p_node.find('input[value=public]').prop('checked');

  if (public) {
    return;
  }
  var ids = [];
  tableContent.children().each(function(i, e) {
    ids.push(e.id);
  })
  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }

  var tbody = jQuery('#' + that);
  var rows = tbody.children('tr');
  rows = Array.prototype.slice.call(rows, 0);

  if (!jQuery(t).attr('type')) {
    jQuery(t).attr('type', 'ascending');
  }

  if (jQuery(t).attr('type') == 'ascending') {
    jQuery(t).attr('type', 'descending')
      .removeClass('ascending').addClass('descending');
    rows.sort(function(row1, row2) {
      var val1 = jQuery(row1).find('.unas_table_text').eq(0).text();
      var val2 = jQuery(row2).find('.unas_table_text').eq(0).text();
      if (val2 > val1) {
        return 1;
      } else if (val2 < val1) {
        return -1;
      } else {
        return 0;
      }
    });

  } else {
    jQuery(t).attr('type', 'ascending')
      .removeClass('descending').addClass('ascending');
    rows.sort(function(row1, row2) {
      var val1 = jQuery(row1).find('.unas_table_text').eq(0).text();
      var val2 = jQuery(row2).find('.unas_table_text').eq(0).text();
      if (val1 > val2) {
        return 1;
      } else if (val1 < val2) {
        return -1;
      } else {
        return 0;
      }
    });
  }
  tbody.append(rows);
}

//Select All
function selectAllOP() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  var tableHead = jQuery(t).closest('table.unas_table_title');
  // var tableContent = tableHead.siblings('.unas_table_content');
  var tableContent = tableHead.parents('.unas_table').find('.unas_table_content');

  var mode = tableHead.attr('mode');
  var modeType = tableHead.attr('type');

  var unas_table = jQuery(t).closest('div.unas_table');
  var p_node = unas_table.siblings('.unas_items');
  var public = p_node.find('input[value=public]').prop('checked');

  if (public) {
    jQuery(t).prop('checked', false);
    return;
  }

  var ids = [];
  tableContent.children().each(function(i, e) {
    ids.push(e.id);
  })

  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }

  var tbody = jQuery('#' + that);
  var cktype = mode + '_' + t.name;

  if (modeType) {
    cktype = modeType + '_' + mode + '_' + t.name;
  }

  jQuery(t).closest('th').siblings().find('input[type=checkbox]').prop('checked', false);
  tbody.children().each(function(i, e) {
    jQuery(e).find('input[type=checkbox]').prop('checked', false);
  })

  if (t.checked) {
    tbody.children().each(function(i, e) {
      jQuery(e).find('input[name=' + cktype + ']').prop('checked', true);
    })

  } else {
    tbody.children().each(function(i, e) {
      jQuery(e).find('input[name=' + cktype + ']').prop('checked', false);
    })
  }

  //兼容万由云
  if (that == 'edit_folder_wanyoucloud_showuser' || that == 'edit_folder_wanyoucloud_showgroup') {
    var c_sel = modeType + '_' + mode; //wanyoucloud_user wanyoucloud_group
    tbody.children().each(function(i, e) {
      var id = jQuery(e).find('input[name=' + cktype + ']').attr('id')
      var length = cktype.length;
      var num = id.substring(length)
      var name = jQuery('#'+c_sel+'_cu'+num).val();
      if (t.name == 'all') {
        wanyoucloudAcl[name] = 'CoxrtncwaTNDd';
      } else if (t.name == 'ro') {
        wanyoucloudAcl[name] = 'xrtnc';
      } else if (t.name == 'rw') {
        wanyoucloudAcl[name] = 'xrtncwaTNDd';
      } else if (t.name == 'no') {
        wanyoucloudAcl[name] = '';
      }
    })
  }

}

function updateSelectAllOP(t) {
  var tableContent = jQuery(t).closest('table.unas_table_content');
  // var tableHead = tableContent.siblings('.unas_table_title');
  var p_tr = jQuery(t).parents('tr');
  var tableHead = tableContent.parents('.unas_table').find('.unas_table_title');

  var mode = tableHead.attr('mode');
  var modeType = tableHead.attr('type');

  var unas_table = jQuery(t).closest('div.unas_table');
  var p_node = unas_table.siblings('.unas_items');

  var ids = [];
  tableContent.children().each(function(i, e) {
    ids.push(e.id);
  })
  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }

  var tbody = jQuery('#' + that);
  var cktype = mode + '_' + t.name;

  if (modeType) {
    cktype = modeType + '_' + mode + '_' + t.name;
  }

  var len = tbody.children().length;

  var ro = [],
    rw = [],
    no = [],
    all = [];

  tableHead.find('input[type=checkbox]').prop('checked', false);
  p_tr.find('input[name=custom]').prop('checked', false);
  tbody.find('input[type=checkbox]:checked').each(function(i, e) {
    var s = e.name.split('_');
    var i_type = s[s.length - 1];
    i_type = i_type == 'cu' ? 'all' : i_type;

    switch (i_type) {
      case 'ro':
        ro.push(i_type);
        if (ro.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'rw':
        rw.push(i_type);
        if (rw.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'no':
        no.push(i_type);
        if (no.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'all':
        all.push(i_type);
        if (all.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      default:
    }
  })

}

function changeMode(t, mode){
  var unas_table = jQuery(t).closest('div.unas_items');
  var p_node = unas_table.siblings('div.unas_table');
  var tableHead = p_node.find('table[mode='+mode+']');
  tableHead.find('input[type=checkbox]').prop('checked', false);
  unas_table.find('input[onkeyup]').val('');

  var tableContent = p_node.find('.unas_table_content');

  var ids = [];
  tableContent.children().each(function(i, e) {
    ids.push(e.id);
  })
  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }

  var tbody = jQuery('#' + that);
  jQuery('#'+that+' tr').show();

  var len = tbody.children().length;

  var ro = [],
    rw = [],
    no = [],
    all = [];

  tbody.find('input[type=checkbox]:checked').each(function(i, e) {
    var s = e.name.split('_');
    var i_type = s[s.length - 1];
    i_type = i_type == 'cu' ? 'all' : i_type;

    switch (i_type) {
      case 'ro':
        ro.push(i_type);
        if (ro.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'rw':
        rw.push(i_type);
        if (rw.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'no':
        no.push(i_type);
        if (no.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      case 'all':
        all.push(i_type);
        if (all.length == len) {
          tableHead.find('input[name='+i_type+']').prop('checked', true);
        }else {
          tableHead.find('input[name='+i_type+']').prop('checked', false);
        }
        break;
      default:
    }
  })
}

function searchUser(){
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  var unas_item = jQuery(t).closest('div.unas_items');
  var currentTable = unas_item.siblings('div.unas_table ').find('.unas_table_content');
  var select = unas_item.find('select.unas_select');
  var mode = select.val();
  var ids = [];
  currentTable.children().each(function(i, e) {
    ids.push(e.id);
  })
  var that = '';
  for (var i = 0; i < ids.length; i++) {
    if (ids[i].indexOf(mode) > -1) {
      that = ids[i];
    }
  }
  jQuery('#'+that+' tr').hide().filter(":contains('" +(t.value) + "')").show();
}
