
var sddl_info = {};
var sddl_not = '';

//点击窗口上部tab后切换显示对应选项容器
jQuery('div[tableid]').click(function() {
  //更新选中样式
  jQuery(this).attr('class', 'unas_tab_sel');
  jQuery(this).siblings().attr('class', 'unas_tab');

  var id = jQuery(this).attr('tableid'); //获取当前点击的tab对应的选项容器的id

  jQuery('.m-container').hide();
  jQuery('#' + id).show();

  if (id == 'jv-privilege-container') {
    jQuery('#shared_folder_editfolder_submit_div').hide();
    jQuery('#shared_folder_editfolder_submit_acl').show();
    getPermission();
  } else {
    jQuery('#shared_folder_editfolder_submit_div').show();
    jQuery('#shared_folder_editfolder_submit_acl').hide();
  }
});


function showWaiting() {
  jQuery('#shared_folder_edit_waiting_content').attr("style", "display:block");
  jQuery('#shared_folder_edit_waiting_logo').attr("style", "display:block");
}

function hideWaiting() {
  jQuery('#shared_folder_edit_waiting_content').attr("style", "display:none");
  jQuery('#shared_folder_edit_waiting_logo').attr("style", "display:none");
}

function SharedFolderCutStr(str, len) {
  if (str == null) {
    return '';
  }
  var str_length = 0;
  var str_len = 0;
  str_cut = new String();
  str_len = str.length;
  for (var i = 0; i < str_len; i++) {
    a = str.charAt(i);
    str_length++;
    if (escape(a).length > 4) {
      str_length++;
    }
    str_cut = str_cut.concat(a);
    if (str_length > len) {
      str_cut = str_cut.concat("...");
      return str_cut;
    }
  }
  if (str_length <= len) {
    return str;
  }
}

function getEditFolderInfo() {
  // showWaiting();

  getEditFolderSMBInfo(); //获取'SMB 权限'信息
  getEditFolderFTPInfo(); //获取'FTP 权限'信息
  getEditFolderWebDAVInfo(); //获取'WebDAV 权限'信息
  getEditFolderAFPInfo(); //获取'AFP 权限'信息
  getEditFolderFileExplorerInfo(); //获取'File Explorer 权限'信息
  getEditFolderWanYouCloudInfo(); //获取'万由云权限'信息
}

//将值为value的option设为选中状态
function selectOptionByValue(select, value) {
  var found = false;
  for (var i = 0, len = select.options.length; i < len; i++) {
    if (select.options[i].value.substr(0, value.length) === value) {
      select.options[i].selected = true;
      found = true;
      break;
    }
  }

  if (!found) {
    //如果找不到对应值，默认选择第一个选项
    select.options[0].selected = true;
  }
}

function getEditFolderSMBInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "folder": folder
      },
      "cmd": "sharedfolder_smb_acquit",
      "token": UToken
    }),
    contentType: "application/json;",
    timeout: 30000,
    dataType: "json",
    success: function(data) {
      if (data.worm) {
        jQuery('#jv-gpsitem').show()
        jQuery('#jv-enableworm').prop('checked', 1);
        jQuery('#jv-gp-s').val(data.graceperiod);
      }else {
        jQuery('#jv-gpsitem').hide();
        jQuery('#jv-enableworm').prop('checked', 0);
      }

      if (data.dirtype == "share") {
        jQuery('#edit_folder_dirtype0').prop("checked", true);
        //if(data.browse == "yes"){
        if (data.browse.toUpperCase() == "YES") {
          jQuery('#edit_folder_browse').prop("checked", false);
        } else {
          jQuery('#edit_folder_browse').prop("checked", true);
        }
        //if(data.recycle == "yes"){
        if (data.recycle_repository == "yes") {
          jQuery('#edit_folder_recycle').prop("checked", true);
        } else {
          jQuery('#edit_folder_recycle').prop("checked", false);
        }
        jQuery('#edit_folder_sharename').val(data.smb_sharename);

        var vg = jQuery('#edit_folder_vg').val();
        var lv = jQuery('#edit_folder_lv').val();
        var folder_name = jQuery('#edit_folder_oldname').val();
        if (data.format == "1" || (data.smb_sharename == vg + "_" + lv + "_" + folder_name)) {
          jQuery('#edit_folder_sharedformat').prop("checked", true);
          jQuery('#edit_folder_sharename').prop("disabled", true);
          jQuery('#edit_folder_oldsharename').val("");
        } else {
          jQuery('#edit_folder_sharedformat').prop("checked", false);
          jQuery('#edit_folder_sharename').prop("disabled", false);
          jQuery('#edit_folder_oldsharename').val(data.smb_sharename);
        }

        jQuery('#edit_folder_account_type').val('user');
        jQuery('#edit_folder_account_type').prop("disabled", false);

        if (data.privilege == "public") {
          jQuery('#edit_folder_public').prop("checked", true);
          jQuery('#edit_folder_account_type').prop("disabled", true);
          //jQuery('#edit_folder_permission_cur').val("public");
          jQuery('#edit_folder_showuser').html("");
          jQuery('#edit_folder_showgroup').html("");
        } else {
          jQuery('#edit_folder_perm').prop("checked", true);
          jQuery('#edit_folder_account_type').prop("disabled", false);

          //jQuery('#edit_folder_permission_cur').val("perm");
          var userlist = "";
          jQuery('#edit_folder_showuser').html('');
          for (var i = 0; i < data.user.length; i++) {
            userlist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.user[i].name + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.user[i].type) + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_ro" id="user_ro' + i + '" value="' + data.user[i].name + '" onclick="editshare_ro_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_rw" id="user_rw' + i + '" value="' + data.user[i].name + '" onclick="editshare_rw_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_no" id="user_no' + i + '" value="' + data.user[i].name + '" onclick="editshare_no_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.user[i].perm == "no" ? "checked" : "") + '/>' + '</span></td>' +
              '</tr>';
            jQuery('#edit_folder_showuser').append(userlist);
          }
          jQuery("#edit_folder_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_showuser tr:odd').addClass("tr_odd");
          });
          var grouplist = "";
          jQuery('#edit_folder_showgroup').html("");
          for (var i = 0; i < data.group.length; i++) {
            grouplist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.group[i].name + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.group[i].type) + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_ro" id="group_ro' + i + '" value="' + data.group[i].name + '" onclick="editshare_ro_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_rw" id="group_rw' + i + '" value="' + data.group[i].name + '" onclick="editshare_rw_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_no" id="group_no' + i + '" value="' + data.group[i].name + '" onclick="editshare_no_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.group[i].perm == "no" ? "checked" : "") + '/>' + '</span></td>' +
              '</tr>';
            jQuery('#edit_folder_showgroup').append(grouplist);
          }
          jQuery("#edit_folder_showgroup tr:even").addClass("tr_even");
          jQuery('#edit_folder_showgroup tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_showgroup tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_showgroup tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_showgroup tr:even").addClass("tr_even");
            jQuery('#edit_folder_showgroup tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_dirtype1').prop("checked", true);
        jQuery('#edit_folder_browse').prop("disabled", true);
        jQuery('#edit_folder_browse').prop("checked", false);
        jQuery('#edit_folder_recycle').prop("disabled", true);
        jQuery('#edit_folder_recycle').prop("checked", false);
        jQuery('#edit_folder_sharename').val('');
        jQuery('#edit_folder_sharename').prop("disabled", true);
        jQuery('#edit_folder_sharedformat').prop("checked", false);
        jQuery('#edit_folder_sharedformat').prop("disabled", true);

        jQuery('#edit_folder_oldsharename').val('');
        jQuery('#edit_folder_public').prop("disabled", true);
        jQuery('#edit_folder_perm').prop("disabled", true);
        jQuery('#edit_folder_account_type').prop("disabled", true);
        jQuery('#edit_folder_showuser').html("");
        jQuery('#edit_folder_showgroup').html("");
      }
      jQuery('#edit_folder_showuser').show();
      jQuery('#edit_folder_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    },
    complete: function() {
      hideWaiting();
    }
  });
}


function getEditFolderFTPInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_ftp_loadby",
      "token": UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      if (data.results.dirtype == "share" && data.results.active == 1) {
        jQuery('#edit_folder_ftp_dirtype0').prop("checked", true);
        jQuery('#edit_folder_ftp_sharename').val(data.results.alias);
        jQuery('#edit_folder_ftp_account_type').val('user');
        jQuery('#edit_folder_ftp_account_type').prop("disabled", false);

        var vg = jQuery('#edit_folder_vg').val();
        var lv = jQuery('#edit_folder_lv').val();
        var folder_name = jQuery('#edit_folder_oldname').val();
        if (data.results.format == "1" || (data.results.alias == vg + "_" + lv + "_" + folder_name)) {
          jQuery('#edit_folder_ftp_sharedformat').prop("checked", true);
          jQuery('#edit_folder_ftp_sharename').prop("disabled", true);
          jQuery('#edit_folder_ftp_oldsharename').val("");
        } else {
          jQuery('#edit_folder_ftp_sharedformat').prop("checked", false);
          jQuery('#edit_folder_ftp_sharename').prop("disabled", false);
          jQuery('#edit_folder_ftp_oldsharename').val(data.alias);
        }

        if (data.results.privilege == "public") {
          jQuery('#edit_folder_ftp_public').prop("checked", true);
          jQuery('#edit_folder_ftp_account_type').prop("disabled", true);
          jQuery('#edit_folder_ftp_showuser').html("");
          jQuery('#edit_folder_ftp_showgroup').html("");
        } else {
          jQuery('#edit_folder_ftp_public').prop("checked", false);
          jQuery('#edit_folder_ftp_account_type').prop("disabled", false);

          var userlist = "";
          jQuery('#edit_folder_ftp_showuser').html('');
          if (data.results.user.length > 0) {
            for (var i = 0; i < data.results.user.length; i++) {
              userlist = '<tr>' +
                '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
                '<td width="15%" align="center"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
                '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_ro" id="ftp_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
                '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_rw" id="ftp_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
                '<td  width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_no" id="ftp_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "" ? "checked" : "") + '/></span></td>' +
                '</tr>';
              jQuery('#edit_folder_ftp_showuser').append(userlist);
            }
          }
          jQuery("#edit_folder_ftp_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_ftp_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_ftp_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_ftp_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_ftp_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_ftp_showuser tr:odd').addClass("tr_odd");
          });
          var grouplist = "";
          jQuery('#edit_folder_ftp_showgroup').html("");
          for (var i = 0; i < data.results.group.length; i++) {
            grouplist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_ro" id="ftp_group_ro' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_rw" id="ftp_group_rw' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_no" id="ftp_group_no' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "" ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_ftp_showgroup').append(grouplist);
          }
          jQuery("#edit_folder_ftp_showgroup tr:even").addClass("tr_even");
          jQuery('#edit_folder_ftp_showgroup tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_ftp_showgroup tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_ftp_showgroup tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_ftp_showgroup tr:even").addClass("tr_even");
            jQuery('#edit_folder_ftp_showgroup tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_ftp_dirtype1').prop("checked", true);
        jQuery('#edit_folder_ftp_public').prop("disabled", true);
        jQuery('#edit_folder_ftp_sharename').prop("disabled", true);
        jQuery('#edit_folder_ftp_sharedformat').prop("checked", false);
        jQuery('#edit_folder_ftp_sharedformat').prop("disabled", true);

        jQuery('#edit_folder_ftp_oldsharename').val('');
        jQuery('#edit_folder_ftp_account_type').prop("disabled", true);
        jQuery('#edit_folder_ftp_showuser').html("");
        jQuery('#edit_folder_ftp_showgroup').html("");
      }
      jQuery('#edit_folder_ftp_showuser').show();
      jQuery('#edit_folder_ftp_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    },
    complete: function() {
      hideWaiting();
    }
  });
}


function getEditFolderWebDAVInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "sharedfolder_webdav_loadby",
      "token": UToken,
      "params": {
        "path": path,
        "sharename": folder,
      }
    }),
    contentType: "application/json",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      if (data.results.dirtype == "share") {
        jQuery('#edit_folder_webdav_dirtype0').prop("checked", true);
        jQuery('#edit_folder_webdav_sharename').val(data.results.alias);
        jQuery('#edit_folder_webdav_account_type').val('user');
        jQuery('#edit_folder_webdav_account_type').prop("disabled", false);

        var vg = jQuery('#edit_folder_vg').val();
        var lv = jQuery('#edit_folder_lv').val();
        var folder_name = jQuery('#edit_folder_oldname').val();
        if (data.results.format == "1" || (data.results.alias == vg + "_" + lv + "_" + folder_name)) {
          jQuery('#edit_folder_webdav_sharedformat').prop("checked", true);
          jQuery('#edit_folder_webdav_sharename').prop("disabled", true);
          jQuery('#edit_folder_webdav_oldsharename').val("");
        } else {
          jQuery('#edit_folder_webdav_sharedformat').prop("checked", false);
          jQuery('#edit_folder_webdav_sharename').prop("disabled", false);
          jQuery('#edit_folder_webdav_oldsharename').val(data.alias);
        }
        if (data.results.privilege == "public") {
          jQuery('#edit_folder_webdav_public').prop("checked", true);
          jQuery('#edit_folder_webdav_account_type').prop("disabled", true);
          jQuery('#edit_folder_webdav_showuser').html("");
        } else {
          jQuery('#edit_folder_webdav_public').prop("checked", false);
          jQuery('#edit_folder_webdav_account_type').prop("disabled", false);

          var userlist = "";
          jQuery('#edit_folder_webdav_showuser').html('');
          if (JSON.stringify(data.results.user) == "[]" || JSON.stringify(data.results.user) == "{}") {
            return
          }
          for (var i = 0; i < data.results.user.length; i++) {
            userlist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_ro" id="webdav_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_rw" id="webdav_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_no" id="webdav_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "" ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_webdav_showuser').append(userlist);
          }
          jQuery("#edit_folder_webdav_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_webdav_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_webdav_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_webdav_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_webdav_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_webdav_showuser tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_webdav_dirtype1').prop("checked", true);
        jQuery('#edit_folder_webdav_public').prop("disabled", true);
        jQuery('#edit_folder_webdav_account_type').prop("disabled", true);
        jQuery('#edit_folder_webdav_showuser').html("");
        jQuery('#edit_folder_webdav_showgroup').html("");
        jQuery('#edit_folder_webdav_sharename').prop("disabled", true);
        jQuery('#edit_folder_webdav_sharedformat').prop("checked", false);
        jQuery('#edit_folder_webdav_sharedformat').prop("disabled", true);

        jQuery('#edit_folder_webdav_oldsharename').val('');
      }
      jQuery('#edit_folder_webdav_showuser').show();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    },
    complete: function() {
      hideWaiting();
    }
  });
}

function getEditFolderFileExplorerInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_fileexplorer_loadby",
      token: UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      if (data.results.dirtype == "share") {
        jQuery('#edit_folder_fileexplorer_dirtype0').prop("checked", true);

        jQuery('#edit_folder_fileexplorer_account_type').val('user');
        jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", false);

        if (data.results.privilege == "public") {
          jQuery('#edit_folder_fileexplorer_public').prop("checked", true);
          jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", true);
          jQuery('#edit_folder_fileexplorer_showuser').html("");
        } else {
          jQuery('#edit_folder_fileexplorer_public').prop("checked", false);
          jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", false);

          var userlist = "";
          jQuery('#edit_folder_fileexplorer_showuser').html('');
          for (var i = 0; i < data.results.user.length; i++) {
            userlist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_ro" id="fileexplorer_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_rw" id="fileexplorer_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_no" id="fileexplorer_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + ((data.results.user[i].perm == "deny") ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_fileexplorer_showuser').append(userlist);
          }
          jQuery("#edit_folder_fileexplorer_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_fileexplorer_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_fileexplorer_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_fileexplorer_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_fileexplorer_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_fileexplorer_showuser tr:odd').addClass("tr_odd");
          });
          var grouplist = "";
          jQuery('#edit_folder_fileexplorer_showgroup').html('');
          for (var i = 0; i < data.results.group.length; i++) {
            grouplist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_ro" id="fileexplorer_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_rw" id="fileexplorer_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_no" id="fileexplorer_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + ((data.results.group[i].perm == "deny") ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_fileexplorer_showgroup').append(grouplist);
          }
          jQuery("#edit_folder_fileexplorer_showgroup tr:even").addClass("tr_even");
          jQuery('#edit_folder_fileexplorer_showgroup tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_fileexplorer_showgroup tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_fileexplorer_showgroup tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_fileexplorer_showgroup tr:even").addClass("tr_even");
            jQuery('#edit_folder_fileexplorer_showgroup tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_fileexplorer_dirtype1').prop("checked", true);
        jQuery('#edit_folder_fileexplorer_public').prop("disabled", true);
        jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", true);
        jQuery('#edit_folder_fileexplorer_showuser').html("");
        jQuery('#edit_folder_fileexplorer_showgroup').html("");
      }
      jQuery('#edit_folder_fileexplorer_showuser').show();
      jQuery('#edit_folder_fileexplorer_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    },
    complete: function() {
      hideWaiting();
    }
  });
}

function acl_line(ace) {
  var sid, name, type, perm, flags, sddltype
  perm = {
    'value': '0x00100000'
  }
  ace.details.forEach((item, i) => {
    switch (item.title) {
      case "Type":
        type = item.value;
        break
      case "Flags":
        flags = item.value;
        break
      case "Rights":
        perm = item;
        if (perm.value.indexOf('0x') == -1) {
          perm_hex = 0
          // Alphabet described rights
          for (var i = 0; i < perm.value.length / 2; i++) {
            sd = perm.value.substr(i * 2, 2)
            if (typeof(SddlAceRights2int[sd]) != 'undefined') {
              perm_hex = perm_hex | SddlAceRights2int[sd]
            }
          }
          perm.value = '0x00' + perm_hex.toString(16)
        }
        break
      case "AccountSid":
        sid = item.value;
        name = item.details;
        break
    }
  })
  return [sid, perm.value];
}


function getPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    url: "/api/acl/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      cmd: "acl_getsddl",
      token: UToken,
      params: {
        path: path,
        nasuser: 1
      }
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      var info = sddl_info = data.results || {};
      var nasuser = info.nas.user || [];
      var nasgroup = info.nas.group || [];
      var group_map = sddl_info.map.group;
      var user_map = sddl_info.map.user;

      var user = {};
      var group = {};
      var sysuser = {};
      var sysgroup = {};

      var aces = {};
      oldsddl = sddl_info.sddl;
      var sddl = sddlParseAny(sddl_info.sddl);
      sddl.details.forEach((header_item, num) => {
        switch (header_item.value) {
          case 'O':
            // owner
            sid = header_item.details.value;
            jQuery("#jv-editacl_owner_val").attr('value', sid);
            break;
          case 'G':
            // group
            sid = header_item.details.value;
            jQuery("#jv-editacl_group_val").attr('value', sid);
            break
          case 'D':
            header_item.details.details.forEach((item, i) => {
              switch (item.title) {
                case "Flags":
                  flags = item.value;
                  SE_DACL_PROTECTED = false;
                  SE_DACL_AUTO_INHERITED = false;
                  item.details.forEach((dacl_flag, j) => {
                    if (dacl_flag["value"] == "AI") {
                      SE_DACL_AUTO_INHERITED = true;
                    } else
                    if (dacl_flag["value"] == "P") {
                      SE_DACL_PROTECTED = true;
                    }
                  })
                  if (SE_DACL_AUTO_INHERITED && !SE_DACL_PROTECTED) {
                    jQuery('#jv_editinherit')[0].checked = true;
                  }else {
                    jQuery('#jv_editinherit')[0].checked = false;
                  }
                  break

                case "ACEs":
                  aces = item.details;
                  break;
              }
            })
            break;
          default:
        }
      })

      for (var v in info.user) {
        if (info.user.hasOwnProperty(v)) {
          if (nasuser.includes(info.user[v])) {
            user[v] = info.user[v];
          }else {
            sysuser[v] = info.user[v];
          }
        }
      }
      for (var v in info.group) {
        if (info.group.hasOwnProperty(v)) {
          if (nasgroup.includes(info.group[v])) {
            group[v] = info.group[v];
          }else {
            sysgroup[v] = info.group[v];
          }
        }
      }

      for (var y = 0; y < aces.length; y++) {
        for (var v in user) {
          if (user.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
        for (var v in group) {
          if (group.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
        for (var v in sysuser) {
          if (sysuser.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
        for (var v in sysgroup) {
          if (sysgroup.hasOwnProperty(v)) {
            if (aces[y].value.indexOf(v) > -1) {
              aces[y]['not'] = 1;
              break;
            }
          }
        }
      }

      sddl_not = '';
      for (var y = 0; y < aces.length; y++) {
        if (!aces[y]['not']) {
          sddl_not += aces[y].value
        }
      }
      var userlist = "";
      jQuery('#edit_folder_showuser-sddl').html('');

      function usersid2name_edit(arr, sid, map, sddluser) {
        var username = [];
        for (var c = 0; c < aces.length; c++){
          var acl = acl_line(aces[c]);
          var s_name = '';
          if (typeof(map[acl[0]]) !== "undefined") {
            s_name = map[acl[0]];
          } else if (typeof(sddluser[acl[0]]) != "undefined") {
            s_name = sddluser[acl[0]];
          }
          for (var v in arr) {
            if (arr.hasOwnProperty(v)) {
              var v_name = "";
              if (typeof(map[v]) !== "undefined") {
                v_name = map[v];
              } else if (typeof(sddluser[v]) != "undefined") {
                v_name = sddluser[v];
              }

              if (s_name == v_name) {
                username.push(v_name)
              }
            }
          }
        }
        var len = 0;
        for (var i = 0; i < username.length; i++) {
          if (username[i] == sid) {
            len ++;
            continue;
          }
        }

        return len;
      }

      var i = 0,
        j = 0;
      for (var v in user) {
        if (user.hasOwnProperty(v)) {
          var perm_type = '';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(user, user[v], user_map, sddl_info.user);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });
              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                  break;
                }

              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }
              } else {
                perm = 'Custom';
                perm_type = 'custom';
                stp = 'row_acl';
                cus = rights;
                break;
              }
            } else {

            }

          }

          userlist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + user[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" ' + (perm_type == "custom" ? "checked" : "") + ' type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_ro" id="sddl_user_ro' + i + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_rw" id="sddl_user_rw' + i + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_user_no" id="sddl_user_no' + i + '" value="" onclick="editshare_no_check(' + "'sddl_user'" + ",'" + i + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#edit_folder_showuser-sddl').append(userlist);
          i++;
        }
      }

      jQuery("#edit_folder_showuser-sddl tr:even").addClass("tr_even");
      jQuery('#edit_folder_showuser-sddl tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showuser-sddl tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showuser-sddl tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showuser-sddl tr:even").addClass("tr_even");
        jQuery('#edit_folder_showuser-sddl tr:odd').addClass("tr_odd");
      });
      var grouplist = "";
      jQuery('#edit_folder_showgroup-sddl').html('');
      for (var v in group) {
        if (group.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(group, group[v], group_map, sddl_info.group);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              // rights = aces[c].details[1].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {

            }
          }
          grouplist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + group[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" ' + (perm_type == "custom" ? "checked" : "") + ' type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_ro" id="sddl_group_ro' + j + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_rw" id="sddl_group_rw' + j + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_group_no" id="sddl_group_no' + j + '" value="" onclick="editshare_no_check(' + "'sddl_group'" + ",'" + j + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#edit_folder_showgroup-sddl').append(grouplist);
          j++;
        }
      }
      jQuery("#edit_folder_showgroup-sddl tr:even").addClass("tr_even");
      jQuery('#edit_folder_showgroup-sddl tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showgroup-sddl tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showgroup-sddl tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showgroup-sddl tr:even").addClass("tr_even");
        jQuery('#edit_folder_showgroup-sddl tr:odd').addClass("tr_odd");
      });

      var syslist = "";
      jQuery('#edit_folder_showsys-sddl').html('');
      var n = 0;
      for (var v in sysuser) {
        if (sysuser.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(sysuser, sysuser[v], user_map, sddl_info.user);

          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              // rights = aces[c].details[1].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {

            }
          }
          syslist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + sysuser[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" '+ (perm_type == "custom" ? "checked" : "") +' type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_ro" id="sddl_sys_ro' + n + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_sys'" + ",'" + n + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_rw" id="sddl_sys_rw' + n + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_sys'" + ",'" + n + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sys_no" id="sddl_sys_no' + n + '" value="" onclick="editshare_no_check(' + "'sddl_sys'" + ",'" + n + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#edit_folder_showsys-sddl').append(syslist);
          n++;
        }
      }
      jQuery("#edit_folder_showsys-sddl tr:even").addClass("tr_even");
      jQuery('#edit_folder_showsys-sddl tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showsys-sddl tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showsys-sddl tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showsys-sddl tr:even").addClass("tr_even");
        jQuery('#edit_folder_showsys-sddl tr:odd').addClass("tr_odd");
      });

      var sysgrouplist = "";
      jQuery('#edit_folder_showsgp-sddl').html('');
      var m = 0;
      for (var v in sysgroup) {
        if (sysgroup.hasOwnProperty(v)) {
          var perm_type = '';
          // var perm_rw = '';
          // var perm_deny = 'deny';
          var perm = '--';
          var stp = '';
          var ace = '';
          var acetype = '';
          var rights = '';
          var cus = '';
          var flg = usersid2name_edit(sysgroup, sysgroup[v], group_map, sddl_info.group);
          for (var c = 0; c < aces.length; c++) {
            var acl = acl_line(aces[c]);
            if (acl[0] == v) {
              ace += aces[c].value;
              // rights = aces[c].details[1].value;
              aces[c].details.forEach((item, i) => {
                if (item.title == "Rights") {
                  rights = item.value;
                }
                if (item.title == "Type") {
                  acetype = item.value;
                }
              });

              if (acl[1] == '0x001200a9') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'ro';
                    perm = 'Read Only';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  perm = 'Custom';
                  perm_type = 'custom';
                  stp = 'row_acl';
                  cus = rights;
                }
              } else if (acl[1] == '0x001f01ff') {
                if (acetype == 'A') {
                  if (flg > 1) {
                    perm = 'Custom';
                    perm_type = 'custom';
                    stp = 'row_acl';
                    cus = rights;
                  }else {
                    perm_type = 'rw';
                    perm = 'Read/Write';
                    stp = 'row_acl';
                    perm_deny = '';
                    break;
                  }
                }else if(acetype == 'D'){
                  stp = 'no_acl';
                  perm = 'No Access';
                  perm_type = 'deny';
                  break;
                }

              } else {
                perm = 'Custom';
                perm_type = 'custom';
                cus = rights;
                stp = 'row_acl';
                break;
              }
            } else {

            }
          }
          sysgrouplist = '<tr class="trp" id="' + v + '" perm="' + rights + '" ace="' + ace + '">' +
            '<td width="20%" align="left"><span class="unas_table_text">' + sysgroup[v] + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text ' + stp + '">' + UNAS._(perm) + '</span></td>' +
            '<td width="12%" align="left"><span class="unas_table_text">' + UNAS._('Local') + '</span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text"><input name="custom" value="'+cus+'" onclick="customsddl(this);" ' + (perm_type == "custom" ? "checked" : "") + ' type="checkbox"></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_ro" id="sddl_sgp_ro' + m + '" value="0x001200a9" onclick="editshare_ro_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "ro" ? "checked" : "") + '/></span></td>' +
            '<td width="13%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_rw" id="sddl_sgp_rw' + m + '" value="0x001f01ff" onclick="editshare_rw_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "rw" ? "checked" : "") + '/></span></td>' +
            '<td width="17%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="sddl_sgp_no" id="sddl_sgp_no' + m + '" value="" onclick="editshare_no_check(' + "'sddl_sgp'" + ",'" + m + "'" + ')" ' + (perm_type == "deny" ? "checked" : "") + '/></span></td>' +
            '</tr>';
          jQuery('#edit_folder_showsgp-sddl').append(sysgrouplist);
          m++;
        }
      }
      jQuery("#edit_folder_showsgp-sddl tr:even").addClass("tr_even");
      jQuery('#edit_folder_showsgp-sddl tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showsgp-sddl tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showsgp-sddl tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showsgp-sddl tr:even").addClass("tr_even");
        jQuery('#edit_folder_showsgp-sddl tr:odd').addClass("tr_odd");
      });

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    },
    complete: function() {
      hideWaiting();
    }
  });
}

function getEditFolderWanYouCloudInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_wanyoucloud_loadby",
      token: UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      if (data.results.dirtype == "share") {
        jQuery('#edit_folder_wanyoucloud_dirtype0').prop("checked", true);
        jQuery('#edit_folder_wanyoucloud_sharename').val(data.results.alias);
        jQuery('#edit_folder_wanyoucloud_account_type').val('user');
        jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", false);

        var vg = jQuery('#edit_folder_vg').val();
        var lv = jQuery('#edit_folder_lv').val();
        var folder_name = jQuery('#edit_folder_oldname').val();
        if (data.results.format == "1" || (data.results.alias == vg + "_" + lv + "_" + folder_name)) {
          jQuery('#edit_folder_wanyoucloud_sharedformat').prop("checked", true);
          jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", true);
          jQuery('#edit_folder_wanyoucloud_oldsharename').val("");
        } else {
          jQuery('#edit_folder_wanyoucloud_sharedformat').prop("checked", false);
          jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", false);
          jQuery('#edit_folder_wanyoucloud_oldsharename').val(data.alias);
        }

        if (data.results.privilege == "public") {
          jQuery('#edit_folder_wanyoucloud_public').prop("checked", true);
          jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", true);
          jQuery('#edit_folder_wanyoucloud_showuser').html("");
        } else {
          jQuery('#edit_folder_fwanyoucloud_public').prop("checked", false);
          jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", false);

          var userlist = "";
          jQuery('#edit_folder_wanyoucloud_showuser').html('');
          for (var i = 0; i < data.results.user.length; i++) {
            wanyoucloudAcl[data.results.user[i].name] = data.results.user[i].acl;
            userlist = '<tr>' +
              '<td width="20%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
              '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
              '<td width="11%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_cu" id="wanyoucloud_user_cu' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_cu_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "cu" ? "checked" : "") + '/></span></td>' +
              '<td width="16%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_all" id="wanyoucloud_user_all' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_all_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "all" ? "checked" : "") + '/></span></td>' +
              '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_ro" id="wanyoucloud_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_rw" id="wanyoucloud_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_no" id="wanyoucloud_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + ((data.results.user[i].perm == "deny") ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_wanyoucloud_showuser').append(userlist);
          }
          jQuery("#edit_folder_wanyoucloud_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_wanyoucloud_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_wanyoucloud_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_wanyoucloud_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_wanyoucloud_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_wanyoucloud_showuser tr:odd').addClass("tr_odd");
          });
          var grouplist = "";
          jQuery('#edit_folder_wanyoucloud_showgroup').html('');
          for (var i = 0; i < data.results.group.length; i++) {
            wanyoucloudAcl['@' + data.results.group[i].name] = data.results.group[i].acl;
            grouplist = '<tr>' +
              '<td width="20%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
              '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
              '<td width="11%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_cu" id="wanyoucloud_group_cu' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_cu_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "cu" ? "checked" : "") + '/></span></td>' +
              '<td width="16%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_all" id="wanyoucloud_group_all' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_all_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "all" ? "checked" : "") + '/></span></td>' +
              '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_ro" id="wanyoucloud_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_rw" id="wanyoucloud_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_no" id="wanyoucloud_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + ((data.results.group[i].perm == "deny") ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_wanyoucloud_showgroup').append(grouplist);
          }
          jQuery("#edit_folder_wanyoucloud_showgroup tr:even").addClass("tr_even");
          jQuery('#edit_folder_wanyoucloud_showgroup tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_wanyoucloud_showgroup tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_wanyoucloud_showgroup tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_wanyoucloud_showgroup tr:even").addClass("tr_even");
            jQuery('#edit_folder_wanyoucloud_showgroup tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_wanyoucloud_dirtype1').prop("checked", true);
        jQuery('#edit_folder_wanyoucloud_public').prop("disabled", true);
        jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", true);
        jQuery('#edit_folder_wanyoucloud_showuser').html("");
        jQuery('#edit_folder_wanyoucloud_showgroup').html("");
        jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", true);
        jQuery('#edit_folder_wanyoucloud_sharedformat').prop("checked", false);
        jQuery('#edit_folder_wanyoucloud_sharedformat').prop("disabled", true);
      }
      jQuery('#edit_folder_wanyoucloud_showuser').show();
      jQuery('#edit_folder_wanyoucloud_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    },
    complete: function() {
      hideWaiting();
    }
  });
}

function getEditFolderAFPInfo() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "sharedfolder_afp_loadby",
      token: UToken,
      params: {
        "path": path,
        "sharename": folder
      }
    }),
    dataType: "json",
    contentType: "application/json;charset=utf-8",
    success: function(data) {
      //alert(JSON.stringify(data))
      if (data.results.dirtype == "share") {
        jQuery('#edit_folder_afp_dirtype0').prop("checked", true);

        jQuery('#edit_folder_afp_account_type').val('user');
        jQuery('#edit_folder_afp_account_type').prop("disabled", false);

        if (data.results.privilege == "public") {
          jQuery('#edit_folder_afp_public').prop("checked", true);
          jQuery('#edit_folder_afp_account_type').prop("disabled", true);
          jQuery('#edit_folder_afp_showuser').html("");
          jQuery('#edit_folder_afp_showgroup').html("");
        } else {
          jQuery('#edit_folder_afp_public').prop("checked", false);
          jQuery('#edit_folder_afp_account_type').prop("disabled", false);

          var userlist = "";
          jQuery('#edit_folder_afp_showuser').html('');
          for (var i = 0; i < data.results.user.length; i++) {
            userlist = '<tr>' +
              '<td width="40%" align="center"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_ro" id="afp_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_rw" id="afp_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_no" id="afp_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "no" ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_afp_showuser').append(userlist);
          }
          jQuery("#edit_folder_afp_showuser tr:even").addClass("tr_even");
          jQuery('#edit_folder_afp_showuser tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_afp_showuser tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_afp_showuser tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_afp_showuser tr:even").addClass("tr_even");
            jQuery('#edit_folder_afp_showuser tr:odd').addClass("tr_odd");
          });
          var grouplist = "";
          jQuery('#edit_folder_afp_showgroup').html("");
          for (var i = 0; i < data.results.group.length; i++) {
            grouplist = '<tr>' +
              '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_ro" id="afp_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_rw" id="afp_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
              '<td width="15%" align="center"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_no" id="afp_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "no" ? "checked" : "") + '/></span></td>' +
              '</tr>';
            jQuery('#edit_folder_afp_showgroup').append(grouplist);
          }
          jQuery("#edit_folder_afp_showgroup tr:even").addClass("tr_even");
          jQuery('#edit_folder_afp_showgroup tr:odd').addClass("tr_odd");
          jQuery('#edit_folder_afp_showgroup tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#edit_folder_afp_showgroup tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#edit_folder_afp_showgroup tr:even").addClass("tr_even");
            jQuery('#edit_folder_afp_showgroup tr:odd').addClass("tr_odd");
          });
        }
      } else {
        jQuery('#edit_folder_afp_dirtype1').prop("checked", true);
        jQuery('#edit_folder_afp_public').prop("disabled", true);
        jQuery('#edit_folder_afp_account_type').prop("disabled", true);
        jQuery('#edit_folder_afp_showuser').html("");
        jQuery('#edit_folder_afp_showgroup').html("");
      }
      jQuery('#edit_folder_afp_showuser').show();
      jQuery('#edit_folder_afp_showgroup').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    },
    complete: function() {
      hideWaiting();
    }
  });
}

function getFolderNFS() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    // url: "/apps/shared-folder/includes/index.php",
    url: '/wmi/index.php',
    type: "POST",
    async: true,
    // data: JSON.stringify({ "cmd":"sharedfolder_nfs_loadby","token": UToken,"params":{"path":path} }),
    data: JSON.encode({
      cmd: 'nfs_loadby',
      token: UToken,
      params: {
        sharename: path
      }
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      jQuery('#edit_folder_shownfs').html('');
      var nfslist = "";
      for (var i in data.results) {
        if (data.results.hasOwnProperty(i)) {
          if (data.results[i].rw) {
            nfslist = '<tr>' +
              '<td nfsruleip="' + data.results[i].client + '" width="60%" align="left"><span class="unas_table_text">' + data.results[i].client + '</span></td>' +
              '<td width="20%" align="center"><span class="unas_table_text">' + UNAS._("Read/Write") + '</span></td>' +
              '<td width="20%" align="center"><a class="unas_icon_delete" onclick="submit_delNfsRule(' + "'" + data.results[i].client + "'" + ');"></a></td>' +
              '<td width=""></td></tr>';
            jQuery('#edit_folder_shownfs').append(nfslist);
          } else {
            nfslist = '<tr>' +
              '<td nfsruleip="' + data.results[i].client + '" width="60%" align="left"><span class="unas_table_text">' + data.results[i].client + '</span></td>' +
              '<td width="20%" align="center"><span class="unas_table_text">' + UNAS._("Read Only") + '</span></td>' +
              '<td width="20%" align="center"><a class="unas_icon_delete" onclick="submit_delNfsRule(' + "'" + data.results[i].client + "'" + ');"></a></td>' +
              '<td width=""></td></tr>';
            jQuery('#edit_folder_shownfs').append(nfslist);
          }
        }
      }

      jQuery("#edit_folder_shownfs tr:even").addClass("tr_even");
      jQuery('#edit_folder_shownfs tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_shownfs tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_shownfs tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_shownfs tr:even").addClass("tr_even");
        jQuery('#edit_folder_shownfs tr:odd').addClass("tr_odd");
      });
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function submit_addNfsRule() {
  var oldfolder = jQuery('#edit_folder_oldname').val();
  var mountpath = jQuery('#edit_folder_path').val();
  var folder = mountpath + "/" + oldfolder;
  var nfsRegWin = new MUI.Modal({
    id: 'nfsRegWindow',
    title: UNAS._('Added NFS Rule'),
    modal: true,
    modalOverlayClose: false,
    width: 750,
    height: 480,
    contentURL: '/apps/shared-folder/nfs_reg.html?v=6.0.71&folder=' + folder
  });
  nfsRegWin.refreshFolderNFS = function() {
    getFolderNFS();
  };
}

function submit_delNfsRule(ip) {
  showWaiting();

  var folder = jQuery('#edit_folder_location').val();
  jQuery.ajax({
    // url: "/apps/shared-folder/includes/index.php",
    url: '/wmi/index.php',
    type: "POST",
    async: true,
    // data: JSON.stringify({ "cmd":"sharedfolder_nfs_delete","token": UToken,"params":{"client":ip,"path": folder} }),
    data: JSON.encode({
      cmd: 'nfs_remove',
      token: UToken,
      params: {
        sharename: folder,
        client: ip
      }
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      getFolderNFS();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    },
    complete: function() {
      hideWaiting();
    }
  });
}



function getFolderSmbPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    //url: "/apps/shared-folder/includes/service_shares.php",
    type: "POST",
    async: true,
    //data: { "path":path, "folder":folder, "action":"getfoldersmbpermission" },
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_smb_loadby",
      "token": UToken
    }),
    contentType: "application/json;",
    timeout: 30000,
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      jQuery('#edit_folder_showuser').html("");
      jQuery('#edit_folder_showgroup').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_ro" id="user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_rw" id="user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="user_no" id="user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "no" ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_showuser').append(userlist);
      }
      jQuery("#edit_folder_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_showuser tr:odd').addClass("tr_odd");
      });
      var grouplist = "";
      for (var i = 0; i < data.results.group.length; i++) {
        grouplist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_ro" id="group_ro' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_rw" id="group_rw' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="group_no" id="group_no' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "no" ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_showgroup').append(grouplist);
      }
      jQuery("#edit_folder_showgroup tr:even").addClass("tr_even");
      jQuery('#edit_folder_showgroup tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_showgroup tr:even").addClass("tr_even");
        jQuery('#edit_folder_showgroup tr:odd').addClass("tr_odd");
      });
      if (jQuery('#edit_folder_account_type').val() == "user") {
        jQuery('#edit_folder_showuser').show();
        jQuery('#edit_folder_showgroup').hide();
      } else {
        jQuery('#edit_folder_showuser').hide();
        jQuery('#edit_folder_showgroup').show();
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    }
  });

}

function getFolderFtpPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_ftp_loadby",
      "token": UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data));
      jQuery('#edit_folder_ftp_showuser').html("");
      jQuery('#edit_folder_ftp_showgroup').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_ro" id="ftp_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_rw" id="ftp_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_user_no" id="ftp_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'ftp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "" ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_ftp_showuser').append(userlist);
      }
      jQuery("#edit_folder_ftp_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_ftp_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_ftp_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_ftp_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_ftp_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_ftp_showuser tr:odd').addClass("tr_odd");
      });
      var grouplist = "";
      for (var i = 0; i < data.results.group.length; i++) {
        grouplist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_ro" id="ftp_group_ro' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_rw" id="ftp_group_rw' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="ftp_group_no" id="ftp_group_no' + i + '" value="' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'ftp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "no" ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_ftp_showgroup').append(grouplist);
      }
      jQuery("#edit_folder_ftp_showgroup tr:even").addClass("tr_even");
      jQuery('#edit_folder_ftp_showgroup tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_ftp_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_ftp_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_ftp_showgroup tr:even").addClass("tr_even");
        jQuery('#edit_folder_ftp_showgroup tr:odd').addClass("tr_odd");
      });
      if (jQuery('#edit_folder_ftp_account_type').val() == "user") {
        jQuery('#edit_folder_ftp_showuser').show();
        jQuery('#edit_folder_ftp_showgroup').hide();
      } else {
        jQuery('#edit_folder_ftp_showuser').hide();
        jQuery('#edit_folder_ftp_showgroup').show();
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    }
  });
}

function getFolderWebDAVPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "sharedfolder_webdav_loadby",
      "token": UToken,
      "params": {
        "path": path,
        "sharename": folder,
      }
    }),
    contentType: "application/json",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data));
      jQuery('#edit_folder_webdav_showuser').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_ro" id="webdav_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_rw" id="webdav_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="webdav_user_no" id="webdav_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'webdav_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "" ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_webdav_showuser').append(userlist);
      }
      jQuery("#edit_folder_webdav_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_webdav_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_webdav_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_webdav_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_webdav_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_webdav_showuser tr:odd').addClass("tr_odd");
      });
      if (jQuery('#edit_folder_webdav_account_type').val() == "user") {
        jQuery('#edit_folder_webdav_showuser').show();
      } else {
        jQuery('#edit_folder_webdav_showuser').hide();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    }
  });
}

function getFolderFileExplorerPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_fileexplorer_loadby",
      token: UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      jQuery('#edit_folder_fileexplorer_showuser').html("");
      jQuery('#edit_folder_fileexplorer_showgroup').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_ro" id="fileexplorer_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_rw" id="fileexplorer_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_user_no" id="fileexplorer_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'fileexplorer_user'" + ",'" + i + "'" + ')" ' + ((data.results.user[i].perm == "deny") ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_fileexplorer_showuser').append(userlist);
      }
      jQuery("#edit_folder_fileexplorer_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_fileexplorer_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_fileexplorer_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_fileexplorer_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_fileexplorer_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_fileexplorer_showuser tr:odd').addClass("tr_odd");
      });

      var grouplist = "";
      for (var i = 0; i < data.results.group.length; i++) {
        grouplist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_ro" id="fileexplorer_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_rw" id="fileexplorer_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="fileexplorer_group_no" id="fileexplorer_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'fileexplorer_group'" + ",'" + i + "'" + ')" ' + ((data.results.group[i].perm == "deny") ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_fileexplorer_showgroup').append(grouplist);
      }
      jQuery("#edit_folder_fileexplorer_showgroup tr:even").addClass("tr_even");
      jQuery('#edit_folder_fileexplorer_showgroup tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_fileexplorer_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_fileexplorer_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_fileexplorer_showgroup tr:even").addClass("tr_even");
        jQuery('#edit_folder_fileexplorer_showgroup tr:odd').addClass("tr_odd");
      });

      if (jQuery('#edit_folder_fileexplorer_account_type').val() == "user") {
        jQuery('#edit_folder_fileexplorer_showuser').show();
        jQuery('#edit_folder_fileexplorer_showgroup').hide();
      } else {
        jQuery('#edit_folder_fileexplorer_showuser').hide();
        jQuery('#edit_folder_fileexplorer_showgroup').show();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    }
  });
}

function getFolderWanYouCloudPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "params": {
        "path": path,
        "sharename": folder,
      },
      "cmd": "sharedfolder_wanyoucloud_loadby",
      token: UToken
    }),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      //alert(JSON.stringify(data))
      jQuery('#edit_folder_wanyoucloud_showuser').html("");
      jQuery('#edit_folder_wanyoucloud_showgroup').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        wanyoucloudAcl[data.results.user[i].name] = data.results.user[i].acl;
        userlist = '<tr>' +
          '<td width="20%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="11%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_cu" id="wanyoucloud_user_cu' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_cu_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "cu" ? "checked" : "") + '/></span></td>' +
          '<td width="16%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_all" id="wanyoucloud_user_all' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_all_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "all" ? "checked" : "") + '/></span></td>' +
          '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_ro" id="wanyoucloud_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_rw" id="wanyoucloud_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_user_no" id="wanyoucloud_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'wanyoucloud_user'" + ",'" + i + "'" + ')" ' + ((data.results.user[i].perm == "deny") ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_wanyoucloud_showuser').append(userlist);
      }
      jQuery("#edit_folder_wanyoucloud_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_wanyoucloud_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_wanyoucloud_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_wanyoucloud_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_wanyoucloud_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_wanyoucloud_showuser tr:odd').addClass("tr_odd");
      });

      var grouplist = "";
      for (var i = 0; i < data.results.group.length; i++) {
        wanyoucloudAcl['@' + data.results.group[i].name] = data.results.group[i].acl;
        grouplist = '<tr>' +
          '<td width="20%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
          '<td width="10%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
          '<td width="11%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_cu" id="wanyoucloud_group_cu' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_cu_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "cu" ? "checked" : "") + '/></span></td>' +
          '<td width="16%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_all" id="wanyoucloud_group_all' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_all_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "all" ? "checked" : "") + '/></span></td>' +
          '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_ro" id="wanyoucloud_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="14%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_rw" id="wanyoucloud_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="wanyoucloud_group_no" id="wanyoucloud_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'wanyoucloud_group'" + ",'" + i + "'" + ')" ' + ((data.results.group[i].perm == "deny") ? "checked" : "") + '/>' + '</span></td>' +
          '</tr>';
        jQuery('#edit_folder_wanyoucloud_showgroup').append(grouplist);
      }
      jQuery("#edit_folder_wanyoucloud_showgroup tr:even").addClass("tr_even");
      jQuery('#edit_folder_wanyoucloud_showgroup tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_wanyoucloud_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_wanyoucloud_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_wanyoucloud_showgroup tr:even").addClass("tr_even");
        jQuery('#edit_folder_wanyoucloud_showgroup tr:odd').addClass("tr_odd");
      });

      if (jQuery('#edit_folder_wanyoucloud_account_type').val() == "user") {
        jQuery('#edit_folder_wanyoucloud_showuser').show();
        jQuery('#edit_folder_wanyoucloud_showgroup').hide();
      } else {
        jQuery('#edit_folder_wanyoucloud_showuser').hide();
        jQuery('#edit_folder_wanyoucloud_showgroup').show();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(UNAS._(textStatus));
    }
  });
}

function getFolderAfpPermission() {
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "sharedfolder_afp_loadby",
      token: UToken,
      params: {
        "path": path,
        "sharename": folder
      }
    }),
    dataType: "json",
    contentType: "application/json;charset=utf-8",
    success: function(data) {
      //alert(JSON.stringify(data))
      jQuery('#edit_folder_afp_showuser').html("");
      jQuery('#edit_folder_afp_showgroup').html("");
      var userlist = "";
      for (var i = 0; i < data.results.user.length; i++) {
        userlist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.user[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.user[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_ro" id="afp_user_ro' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_ro_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_rw" id="afp_user_rw' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_rw_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_user_no" id="afp_user_no' + i + '" value="' + data.results.user[i].name + '" onclick="editshare_no_check(' + "'afp_user'" + ",'" + i + "'" + ')" ' + (data.results.user[i].perm == "no" ? "checked" : "") + '/></span></td></tr>';
        jQuery('#edit_folder_afp_showuser').append(userlist);
      }
      jQuery("#edit_folder_afp_showuser tr:even").addClass("tr_even");
      jQuery('#edit_folder_afp_showuser tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_afp_showuser tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_afp_showuser tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_afp_showuser tr:even").addClass("tr_even");
        jQuery('#edit_folder_afp_showuser tr:odd').addClass("tr_odd");
      });
      var grouplist = "";
      for (var i = 0; i < data.results.group.length; i++) {
        grouplist = '<tr>' +
          '<td width="40%" align="left"><span class="unas_table_text">' + data.results.group[i].name + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + UNAS._(data.results.group[i].type) + '</span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_ro" id="afp_group_ro' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_ro_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "ro" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_rw" id="afp_group_rw' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_rw_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "rw" ? "checked" : "") + '/></span></td>' +
          '<td width="15%" align="left"><span class="unas_table_text">' + '<input type="checkbox" name="afp_group_no" id="afp_group_no' + i + '" value="@' + data.results.group[i].name + '" onclick="editshare_no_check(' + "'afp_group'" + ",'" + i + "'" + ')" ' + (data.results.group[i].perm == "no" ? "checked" : "") + '/></span></td></tr>';
        jQuery('#edit_folder_afp_showgroup').append(grouplist);
      }
      jQuery("#edit_folder_afp_showgroup tr:even").addClass("tr_even");
      jQuery('#edit_folder_afp_showgroup tr:odd').addClass("tr_odd");
      jQuery('#edit_folder_afp_showgroup tr').mouseover(function() {
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery(this).toggleClass("tr_hover");
      });
      jQuery('#edit_folder_afp_showgroup tr').mouseout(function() {
        jQuery(this).toggleClass("tr_hover");
        jQuery(this).removeClass("tr_even tr_odd");
        jQuery("#edit_folder_afp_showgroup tr:even").addClass("tr_even");
        jQuery('#edit_folder_afp_showgroup tr:odd').addClass("tr_odd");
      });
      if (jQuery('#edit_folder_afp_account_type').val() == "user") {
        jQuery('#edit_folder_afp_showuser').show();
        jQuery('#edit_folder_afp_showgroup').hide();
      } else {
        jQuery('#edit_folder_afp_showuser').hide();
        jQuery('#edit_folder_afp_showgroup').show();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
    }
  });
}

function updatebutton() {
  var f = 0;
  jQuery('input[inputtype=inputtype]').each(function(i, e) {
    if (jQuery(e).hasClass('unas_input_error')) {
      f = 1;
    }
  })
  if (f) {
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub_disabled");
    return true;
  } else {
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub");
  }

  return false;
}
jQuery('#edit_folder_name').keyup(function() {
  // this.value = this.value.replace(/\W+/g,'');
  var folder = this.value.trim();
  if (folder == "") {
    jQuery('#edit_folder_name').attr('class', 'unas_input_error');
    jQuery("#edit_folder_info").attr('class', "unas_icon_error");
    jQuery("#edit_folder_info").attr('title', UNAS._("Folder name is empty"));
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub_disabled");
    jQuery("#shared_folder_editfolder_applysubmit").attr("class", "unas_button_sub_disabled");
    return;
  }

  var oldfolder = jQuery('#edit_folder_oldname').val();
  if (folder == oldfolder.trim()) {
    jQuery('#edit_folder_name').attr('class', 'unas_input');
    jQuery("#edit_folder_info").attr('class', '');
    jQuery("#edit_folder_info").attr('title', '');
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub");
    jQuery("#shared_folder_editfolder_applysubmit").attr("class", "");

    updatebutton();

    return;
  }

  var path = jQuery('#edit_folder_path').val();
  isValidSharedFolderName(path, folder, oldfolder);
});


//
jQuery('#edit_folder_sharename').keyup(function() {
  // this.value = this.value.replace(/\W+/g,'');
  var folder = this.value.trim();
  if (folder == "") {
    jQuery("#edit_folder_smb_sharename_info").attr('class', '');
    jQuery('#edit_folder_sharename').attr('class', 'unas_input');
    jQuery("#edit_folder_smb_sharename_info").attr('title', '');
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub_disabled");
    jQuery("#shared_folder_editfolder_applysubmit").attr("class", "unas_button_sub_disabled");
    jQuery("#shared_folder_editfolder_applysubmit").attr("class", "");
    return;
  }

  var oldfolder = jQuery('#edit_folder_oldsharename').val();

  if (folder == oldfolder.trim()) {

    jQuery('#edit_folder_sharename').attr('class', 'unas_input');
    jQuery("#edit_folder_smb_sharename_info").attr('class', '');
    jQuery("#edit_folder_smb_sharename_info").attr('title', '');
    jQuery("#shared_folder_editfolder_submit").attr("class", "unas_button_sub");
    jQuery("#shared_folder_editfolder_applysubmit").attr("class", "");

    updatebutton();
    return;
  }
  var path = jQuery('#edit_folder_path').val();
  isValidSharedFolderName(path, folder, oldfolder);
});


jQuery("#edit_folder_ftp_sharename,#edit_folder_webdav_sharename,#edit_folder_wanyoucloud_sharename").keyup(function() {
  var msg = '';
  if (jQuery(this).val() == '') {
    msg = "Folder name is empty";
  }
  updatainput(jQuery(this).val(), msg);
  updatebutton();

})

function updatainput(f, msg) {
  switch (typeModul) {
    case 'edit_folder_generaloption':
      stateTips('#edit_folder_name', '#edit_folder_info', f, msg);
      break;
    case 'edit_folder_smb_permoption':
      stateTips('#edit_folder_sharename', '#edit_folder_smb_sharename_info', f, msg);
      break;
    case 'edit_folder_ftp_permoption':
      stateTips('#edit_folder_ftp_sharename', '#edit_folder_ftp_sharename_info', f, msg);
      break;
    case 'edit_folder_webdav_permoption':
      stateTips('#edit_folder_webdav_sharename', '#edit_folder_webdav_sharename_info', f, msg);
      break;
    case 'edit_folder_wanyoucloud_permoption':
      stateTips('#edit_folder_wanyoucloud_sharename', '#edit_folder_wanyoucloud_sharename_info', f, msg);
      break;
    default:

  }
}

function stateTips(inputname, errname, f, msg) {
  var v = jQuery(inputname).val();
  msg = v.indexOf("#") != -1 ? 'Invalid folder name' : msg;

  if (f && v.indexOf("#") == -1) {
    jQuery(inputname).attr('class', 'unas_input');
    jQuery(errname).attr('class', '');
    jQuery(errname).attr('title', '');

  } else {
    jQuery(inputname).attr('class', 'unas_input_error');
    jQuery(errname).attr('class', 'unas_icon_error');
    jQuery(errname).attr('title', UNAS._(msg));
  }
}


jQuery('#edit_folder_name').focus(function() {
  if (jQuery('#edit_folder_name').attr('class') != "unas_input_error")
    jQuery('#edit_folder_name').attr('class', 'unas_input');

});
//
jQuery('#edit_folder_sharename').focus(function() {
  if (jQuery('#edit_folder_sharename').attr('class') != "unas_input_error")
    jQuery('#edit_folder_sharename').attr('class', 'unas_input');

});

jQuery('#edit_folder_dirtype1').click(function() {
  jQuery('#edit_folder_sharename').prop("disabled", true);
  jQuery('#edit_folder_sharedformat').prop("disabled", true);
  jQuery('#edit_folder_browse').prop("disabled", true);
  jQuery('#edit_folder_recycle').prop("disabled", true);
  //jQuery('#edit_folder_recycle_no').prop("disabled",true);
  //jQuery('#edit_folder_recycle_public').prop("disabled",true);
  jQuery('#edit_folder_public').prop("disabled", true);
  jQuery('#edit_folder_perm').prop("disabled", true);
  jQuery('#edit_folder_account_type').prop("disabled", true);
  jQuery('#edit_folder_showuser').hide();
  jQuery('#edit_folder_showgroup').hide();
})
jQuery('#edit_folder_dirtype0').click(function() {
  //var sharename = jQuery('#edit_folder_oldname').val();
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldfolder = jQuery('#edit_folder_oldname').val();
  var oldsharename = jQuery('#edit_folder_oldsharename').val();

  if (jQuery('#edit_folder_sharedformat').prop("checked") == true) {
    jQuery('#edit_folder_sharename').prop("disabled", true);
    jQuery('#edit_folder_sharename').val(vg + "_" + lv + "_" + oldfolder);
  } else {
    jQuery('#edit_folder_sharename').prop("disabled", false);
    jQuery('#edit_folder_sharename').val(oldsharename ? oldsharename : oldfolder);
  }
  //jQuery('#edit_folder_sharename').val(sharename);
  jQuery('#edit_folder_sharedformat').prop("disabled", false);
  jQuery('#edit_folder_browse').prop("disabled", false);
  jQuery('#edit_folder_recycle').prop("disabled", false);
  //jQuery('#edit_folder_recycle_no').prop("disabled",false);
  //jQuery('#edit_folder_recycle_public').prop("disabled",false);
  jQuery('#edit_folder_public').prop("disabled", false);
  jQuery('#edit_folder_perm').prop("disabled", false);
  if (jQuery('#edit_folder_public').prop("checked") == true) {
    jQuery('#edit_folder_account_type').prop("disabled", true);
  }
  if (jQuery('#edit_folder_perm').prop("checked") == true) {
    jQuery('#edit_folder_account_type').prop("disabled", false);
    getFolderSmbPermission();
  }
})
jQuery('#edit_folder_sharedformat').click(function() {
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldfolder = jQuery('#edit_folder_oldname').val();
  var oldsharename = jQuery('#edit_folder_oldsharename').val();
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_sharename').prop("disabled", true);
    jQuery('#edit_folder_sharename').val((vg + "_" + lv + "_" + oldfolder).replace(/:/g, ""));
  } else {
    jQuery('#edit_folder_sharename').prop("disabled", false);
    jQuery('#edit_folder_sharename').val(oldsharename ? oldsharename : oldfolder);
  }
});
jQuery('#edit_folder_public').click(function() {
  jQuery('#edit_folder_showuser').hide();
  jQuery('#edit_folder_showgroup').hide();
  jQuery('#edit_folder_account_type').prop("disabled", true);
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_perm').click(function() {
  getFolderSmbPermission();
  jQuery('#edit_folder_account_type').prop("disabled", false);
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_showuser').show();
    jQuery('#edit_folder_showgroup').hide();
    jQuery('#jv-smbSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_showuser').hide();
    jQuery('#edit_folder_showgroup').show();
    jQuery('#jv-smbSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});

jQuery('#jv-accounttype-privilege').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_showuser-sddl').show();
    jQuery('#edit_folder_showgroup-sddl').hide();
    jQuery('#edit_folder_showsys-sddl').hide();
    jQuery('#edit_folder_showsgp-sddl').hide();
    jQuery('#jv-privilege-Sort').attr('mode', 'user');
  } else if(acc_type == "group"){
    jQuery('#edit_folder_showuser-sddl').hide();
    jQuery('#edit_folder_showgroup-sddl').show();
    jQuery('#edit_folder_showsys-sddl').hide();
    jQuery('#edit_folder_showsgp-sddl').hide();
    jQuery('#jv-privilege-Sort').attr('mode', 'group');
  }else if(acc_type == "sys"){
    jQuery('#edit_folder_showuser-sddl').hide();
    jQuery('#edit_folder_showgroup-sddl').hide();
    jQuery('#edit_folder_showsys-sddl').show();
    jQuery('#edit_folder_showsgp-sddl').hide();
    jQuery('#jv-privilege-Sort').attr('mode', 'sys');
  }else {
    jQuery('#edit_folder_showuser-sddl').hide();
    jQuery('#edit_folder_showgroup-sddl').hide();
    jQuery('#edit_folder_showsys-sddl').hide();
    jQuery('#edit_folder_showsgp-sddl').show();
    jQuery('#jv-privilege-Sort').attr('mode', 'sgp');
  }
  changeMode(this, acc_type);
});

jQuery('#edit_folder_ftp_dirtype1').click(function() {
  jQuery('#edit_folder_ftp_public').prop("disabled", true);
  jQuery('#edit_folder_ftp_sharename').prop("disabled", true);
  jQuery('#edit_folder_ftp_sharedformat').prop("disabled", true);
  jQuery('#edit_folder_webdav_sharedformat').prop("disabled", true);
  jQuery('#edit_folder_ftp_account_type').prop("disabled", true);
  jQuery('#edit_folder_ftp_showuser').hide();
  jQuery('#edit_folder_ftp_showgroup').hide();
})
jQuery('#edit_folder_ftp_dirtype0').click(function() {
  //var ftpsharename = jQuery('#edit_folder_oldname').val();
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldftpfolder = jQuery('#edit_folder_oldname').val();
  var oldftpsharename = jQuery('#edit_folder_ftp_oldsharename').val();

  jQuery('#edit_folder_ftp_public').prop("disabled", false);
  jQuery('#edit_folder_ftp_sharedformat').prop("disabled", false);
  if (jQuery('#edit_folder_ftp_sharedformat').prop("checked") == true) {
    jQuery('#edit_folder_ftp_sharename').prop("disabled", true);
    jQuery('#edit_folder_ftp_sharename').val(vg + "_" + lv + "_" + oldftpfolder);
  } else {
    jQuery('#edit_folder_ftp_sharename').prop("disabled", false);
    jQuery('#edit_folder_ftp_sharename').val(oldftpsharename ? oldftpsharename : oldftpfolder);
  }
  //jQuery('#edit_folder_ftp_sharename').val(ftpsharename);
  jQuery('#edit_folder_sharedformat').prop("disabled", false);
  if (jQuery('#edit_folder_ftp_public').prop("checked") == true) {
    jQuery('#edit_folder_ftp_account_type').prop("disabled", true);
  } else {
    jQuery('#edit_folder_ftp_account_type').prop("disabled", false);
    getFolderFtpPermission();
  }
})
jQuery('#edit_folder_webdav_dirtype0').click(function() {
  //var webdavharename = jQuery('#edit_folder_oldname').val();
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldwebdavfolder = jQuery('#edit_folder_oldname').val();
  var oldwebdavsharename = jQuery('#edit_folder_webdav_oldsharename').val();
  jQuery('#edit_folder_webdav_public').prop("disabled", false);
  jQuery('#edit_folder_webdav_sharedformat').prop("disabled", false);
  if (jQuery('#edit_folder_webdav_sharedformat').prop("checked") == true) {
    jQuery('#edit_folder_webdav_sharename').prop("disabled", true);
    jQuery('#edit_folder_webdav_sharename').val(vg + "_" + lv + "_" + oldwebdavfolder);
  } else {
    jQuery('#edit_folder_webdav_sharename').prop("disabled", false);
    jQuery('#edit_folder_webdav_sharename').val(oldwebdavsharename ? oldwebdavsharename : oldwebdavfolder);
  }
  //jQuery('#edit_folder_webdav_sharename').val(webdavharename);
  jQuery('#edit_folder_sharedformat').prop("disabled", false);
  if (jQuery('#edit_folder_webdav_public').prop("checked") == true) {
    jQuery('#edit_folder_webdav_account_type').prop("disabled", true);
  } else {
    jQuery('#edit_folder_webdav_account_type').prop("disabled", false);
    if (jQuery('#edit_folder_webdav_public').prop("checked") != true) {
      getFolderWebDAVPermission();
    }
  }
})
jQuery('#edit_folder_ftp_sharedformat').click(function() {
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldftpfolder = jQuery('#edit_folder_oldname').val();
  var oldftpsharename = jQuery('#edit_folder_ftp_oldsharename').val();
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_ftp_sharename').prop("disabled", true);
    jQuery('#edit_folder_ftp_sharename').val(vg + "_" + lv + "_" + oldftpfolder);
  } else {
    jQuery('#edit_folder_ftp_sharename').prop("disabled", false);
    jQuery('#edit_folder_ftp_sharename').val(oldftpsharename ? oldftpsharename : oldftpfolder);
  }
});
jQuery('#edit_folder_webdav_sharedformat').click(function() {
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldwebdavfolder = jQuery('#edit_folder_oldname').val();
  var oldwebdavsharename = jQuery('#edit_folder_webdav_oldsharename').val();
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_webdav_sharename').prop("disabled", true);
    jQuery('#edit_folder_webdav_sharename').val(vg + "_" + lv + "_" + oldwebdavfolder);
  } else {
    jQuery('#edit_folder_webdav_sharename').prop("disabled", false);
    jQuery('#edit_folder_webdav_sharename').val(oldwebdavsharename ? oldwebdavsharename : oldwebdavfolder);
  }
});
jQuery('#edit_folder_ftp_public').click(function() {
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_ftp_showuser').hide();
    jQuery('#edit_folder_ftp_showgroup').hide();
    jQuery('#edit_folder_ftp_account_type').prop("disabled", true);
  } else {
    getFolderFtpPermission();
    jQuery('#edit_folder_ftp_account_type').prop("disabled", false);
  }
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_ftp_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_ftp_showuser').show();
    jQuery('#edit_folder_ftp_showgroup').hide();
    jQuery('#jv-ftpSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_ftp_showuser').hide();
    jQuery('#edit_folder_ftp_showgroup').show();
    jQuery('#jv-ftpSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});

jQuery('#edit_folder_webdav_dirtype1').click(function() {
  jQuery('#edit_folder_webdav_public').prop("disabled", true);
  jQuery('#edit_folder_webdav_account_type').prop("disabled", true);
  jQuery('#edit_folder_webdav_showuser').hide();
  jQuery('#edit_folder_webdav_sharedformat').prop("disabled", true);
  jQuery('#edit_folder_webdav_sharename').prop("disabled", true);

})
//		jQuery('#edit_folder_webdav_dirtype0').click(function(){
//			jQuery('#edit_folder_webdav_public').prop("disabled",false);
//			if(jQuery('#edit_folder_webdav_public').prop("checked") == true){
//				jQuery('#edit_folder_webdav_account_type').prop("disabled",true);
//			}else{
//				jQuery('#edit_folder_webdav_account_type').prop("disabled",false);
//				if(jQuery('#edit_folder_webdav_public').prop("checked") != true){
//					getFolderWebDAVPermission();
//				}
//			}
//		})
jQuery('#edit_folder_webdav_public').click(function() {
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_webdav_showuser').hide();
    jQuery('#edit_folder_webdav_account_type').prop("disabled", true);
  } else {
    getFolderWebDAVPermission();
    jQuery('#edit_folder_webdav_account_type').prop("disabled", false);
  }
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_webdav_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_webdav_showuser').show();
    jQuery('#jv-webdavSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_webdav_showuser').hide();
    jQuery('#jv-webdavSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});


jQuery('#edit_folder_fileexplorer_dirtype1').click(function() {
  jQuery('#edit_folder_fileexplorer_public').prop("disabled", true);
  jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", true);
  jQuery('#edit_folder_fileexplorer_showuser').hide();
  jQuery('#edit_folder_fileexplorer_showgroup').hide();
})
jQuery('#edit_folder_fileexplorer_dirtype0').click(function() {
  jQuery('#edit_folder_fileexplorer_public').prop("disabled", false);
  if (jQuery('#edit_folder_fileexplorer_public').prop("checked") == true) {
    jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", true);
  } else {
    jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", false);
    getFolderFileExplorerPermission();
  }
})
jQuery('#edit_folder_fileexplorer_public').click(function() {
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_fileexplorer_showuser').hide();
    jQuery('#edit_folder_fileexplorer_showgroup').hide();
    jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", true);
  } else {
    getFolderFileExplorerPermission();
    jQuery('#edit_folder_fileexplorer_account_type').prop("disabled", false);
  }
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_fileexplorer_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_fileexplorer_showuser').show();
    jQuery('#edit_folder_fileexplorer_showgroup').hide();
    jQuery('#jv-fileSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_fileexplorer_showuser').hide();
    jQuery('#edit_folder_fileexplorer_showgroup').show();
    jQuery('#jv-fileSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});

jQuery('#edit_folder_wanyoucloud_dirtype1').click(function() {
  jQuery('#edit_folder_wanyoucloud_public').prop("disabled", true);
  jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", true);
  jQuery('#edit_folder_wanyoucloud_showuser').hide();
  jQuery('#edit_folder_wanyoucloud_showgroup').hide();
  jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", true);
})
jQuery('#edit_folder_wanyoucloud_dirtype0').click(function() {
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldwanyoucloudfolder = jQuery('#edit_folder_oldname').val();
  var oldwanyoucloudsharename = jQuery('#edit_folder_wanyoucloud_oldsharename').val();
  jQuery('#edit_folder_wanyoucloud_public').prop("disabled", false);
  jQuery('#edit_folder_wanyoucloud_sharedformat').prop("disabled", false);
  if (jQuery('#edit_folder_wanyoucloud_sharedformat').prop("checked") == true) {
    jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", true);
    jQuery('#edit_folder_wanyoucloud_sharename').val(vg + "_" + lv + "_" + oldwanyoucloudfolder);
  } else {
    jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", false);
    jQuery('#edit_folder_wanyoucloud_sharename').val(oldwanyoucloudsharename ? oldwanyoucloudsharename : oldwanyoucloudfolder);
  }
  jQuery('#edit_folder_wanyoucloud_public').prop("disabled", false);
  if (jQuery('#edit_folder_wanyoucloud_public').prop("checked") == true) {
    jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", true);
  } else {
    jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", false);
    if (jQuery('#edit_folder_wanyoucloud_public').prop("checked") != true) {
      getFolderWanYouCloudPermission();
    }
  }
})
jQuery('#edit_folder_wanyoucloud_sharedformat').click(function() {
  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var oldwanyoucloudfolder = jQuery('#edit_folder_oldname').val();
  var oldwanyoucloudsharename = jQuery('#edit_folder_wanyoucloud_oldsharename').val();
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", true);
    jQuery('#edit_folder_wanyoucloud_sharename').val(vg + "_" + lv + "_" + oldwanyoucloudfolder);
  } else {
    jQuery('#edit_folder_wanyoucloud_sharename').prop("disabled", false);
    jQuery('#edit_folder_wanyoucloud_sharename').val(oldwanyoucloudsharename ? oldwanyoucloudsharename : oldwanyoucloudfolder);
  }
});
jQuery('#edit_folder_wanyoucloud_public').click(function() {
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_wanyoucloud_showuser').hide();
    jQuery('#edit_folder_wanyoucloud_showgroup').hide();
    jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", true);
  } else {
    getFolderWanYouCloudPermission();
    jQuery('#edit_folder_wanyoucloud_account_type').prop("disabled", false);
  }
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_wanyoucloud_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_wanyoucloud_showuser').show();
    jQuery('#edit_folder_wanyoucloud_showgroup').hide();
    jQuery('#jv-wycSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_wanyoucloud_showuser').hide();
    jQuery('#edit_folder_wanyoucloud_showgroup').show();
    jQuery('#jv-wycSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});


jQuery('#edit_folder_afp_dirtype1').click(function() {
  jQuery('#edit_folder_afp_public').prop("disabled", true);
  jQuery('#edit_folder_afp_account_type').prop("disabled", true);
  jQuery('#edit_folder_afp_showuser').hide();
  jQuery('#edit_folder_afp_showgroup').hide();
})
jQuery('#edit_folder_afp_dirtype0').click(function() {
  jQuery('#edit_folder_afp_public').prop("disabled", false);
  if (jQuery('#edit_folder_afp_public').prop("checked") == true) {
    jQuery('#edit_folder_afp_account_type').prop("disabled", true);
  } else {
    jQuery('#edit_folder_afp_account_type').prop("disabled", false);
    getFolderAfpPermission();
  }
})
jQuery('#edit_folder_afp_public').click(function() {
  if (jQuery(this).prop("checked") == true) {
    jQuery('#edit_folder_afp_showuser').hide();
    jQuery('#edit_folder_afp_showgroup').hide();
    jQuery('#edit_folder_afp_account_type').prop("disabled", true);
  } else {
    getFolderAfpPermission();
    jQuery('#edit_folder_afp_account_type').prop("disabled", false);
  }
  jQuery(this).closest('li.unas_item_li').siblings().find('input[onkeyup]').val('');
});
jQuery('#edit_folder_afp_account_type').change(function() {
  var acc_type = jQuery(this).val();
  if (acc_type == "user") {
    jQuery('#edit_folder_afp_showuser').show();
    jQuery('#edit_folder_afp_showgroup').hide();
    jQuery('#jv-afpSort').attr('mode', 'user');
  } else {
    jQuery('#edit_folder_afp_showuser').hide();
    jQuery('#edit_folder_afp_showgroup').show();
    jQuery('#jv-afpSort').attr('mode', 'group');
  }
  changeMode(this, acc_type);
});

function isValidSharedFolderName(path, folder, oldfolder) {
  var state;
  if (oldfolder === undefined)
    oldfolder = "";
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: false,
    dataType: "json",
    contentType: "application/json;charset=utf-8",
    data: JSON.stringify({
      cmd: "sharedfolder_check_name",
      token: UToken,
      params: {
        'path': path,
        'name': folder
      }
    }),
    success: function(data) {
      if (data.err == 0) {
        updatainput(1, '');

      } else {
        updatainput(0, data.errmsg);
      }

      updatebutton();

      state = data.state;
    }
  });
  return (state);
}

function editshare_ro_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (jQuery('#' + c_sel + '_ro' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

    if (c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
      var name = jQuery('#' + c_sel + '_cu' + num).val();
      wanyoucloudAcl[name] = 'xrtnc';
    }
  } else {
    //取消勾选时不修改acl缓存
    // if(c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
    // 	var name = jQuery('#'+c_sel+'_cu'+num).val();
    // 	wanyoucloudAcl[name] = '';
    // }
  }
  updateSelectAllOP(t);
}

function editshare_rw_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_rw' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

    if (c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
      var name = jQuery('#' + c_sel + '_cu' + num).val();
      wanyoucloudAcl[name] = 'xrtncwaTNDd';
    }
  } else {
    //取消勾选时不修改acl缓存
    // if(c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
    // 	var name = jQuery('#'+c_sel+'_cu'+num).val();
    // 	wanyoucloudAcl[name] = '';
    // }
  }
  updateSelectAllOP(t);
}

function editshare_no_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (jQuery('#' + c_sel + '_no' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

    if (c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
      var name = jQuery('#' + c_sel + '_cu' + num).val();
      wanyoucloudAcl[name] = '';
    }
  } else {
    //取消勾选时不修改acl缓存
    // if(c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
    // 	var name = jQuery('#'+c_sel+'_cu'+num).val();
    // 	wanyoucloudAcl[name] = '';
    // }
  }
  updateSelectAllOP(t);
}

function editshare_cu_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_cu' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_all' + num).prop('checked', false)

    if (c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
      var name = jQuery('#' + c_sel + '_cu' + num).val();
      var type = 'user';
      if (name.substr(0, 1) == '@') {
        type = 'group';
        name = name.substr(1);
      }

      if (wanyoucloudAcl[name] === undefined || wanyoucloudAcl[name] === null) {
        wanyoucloudAcl[name] = '';
      }

      EditAclWindowFun(type, name, wanyoucloudAcl[name]);
    }
  } else {
    //取消勾选时不修改acl缓存
    // if(c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
    // 	var name = jQuery('#'+c_sel+'_cu'+num).val();
    // 	wanyoucloudAcl[name] = '';
    // }
  }
  updateSelectAllOP(t);
}

function editshare_all_check(c_sel, num) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;

  if (jQuery('#' + c_sel + '_all' + num).prop('checked') == true) {
    jQuery('#' + c_sel + '_rw' + num).prop('checked', false)
    jQuery('#' + c_sel + '_ro' + num).prop('checked', false)
    jQuery('#' + c_sel + '_no' + num).prop('checked', false)
    jQuery('#' + c_sel + '_cu' + num).prop('checked', false)

    if (c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
      var name = jQuery('#' + c_sel + '_cu' + num).val();
      wanyoucloudAcl[name] = 'CoxrtncwaTNDd';
    }
  } else {
    //取消勾选时不修改acl缓存
    // if(c_sel == 'wanyoucloud_user' || c_sel == 'wanyoucloud_group') {
    // 	var name = jQuery('#'+c_sel+'_cu'+num).val();
    // 	wanyoucloudAcl[name] = '';
    // }
  }
  updateSelectAllOP(t);
}

function submit_editSharedFolder() {
  var folder = jQuery('#edit_folder_name').val();
  var oldfolder = jQuery('#edit_folder_oldname').val();
  var mountpath = jQuery('#edit_folder_path').val();
  commit_editSharedFolder(mountpath, folder, oldfolder);
}

function commit_editSharedFolder(mountpath, folder, oldfolder) {
  if (jQuery('#edit_folder_name').attr('class') == 'unas_input_error') {
    return;
  }
  //
  if (jQuery('#edit_folder_sharename').attr('class') == 'unas_input_error') {
    return;
  }

  var vg = jQuery('#edit_folder_vg').val();
  var lv = jQuery('#edit_folder_lv').val();
  var dirtype = "";
  if (jQuery('#edit_folder_dirtype0').prop("checked") == true)
    dirtype = 1;
  if (jQuery('#edit_folder_dirtype1').prop("checked") == true)
    dirtype = 0;

  var sharename = jQuery('#edit_folder_sharename').val() ? jQuery('#edit_folder_sharename').val() : folder;
  var oldP = mountpath + "/" + oldfolder;
  var currP = mountpath + "/" + folder;

  var permission = "";
  if (jQuery('#edit_folder_public').prop("checked") == true)
    permission = "public"
  if (jQuery('#edit_folder_perm').prop("checked") == true)
    permission = "perm";

  if ((jQuery('#edit_folder_browse').prop("checked") == true) && (jQuery('#edit_folder_browse').prop("disabled") == false)) {
    var browse = 0;
  } else {
    var browse = 1;
  }
  //if( (jQuery('#edit_folder_recycle').prop("checked") == true)&&(jQuery('#edit_folder_recycle').prop("disabled") == false) ){
  //	var recycle = 1;
  //}else if ((jQuery('#edit_folder_recycle_no').prop("checked") == true)&&(jQuery('#edit_folder_recycle').prop("disabled") == false)) {
  //	var recycle = 0;
  //}else if ((jQuery('#edit_folder_recycle_public').prop("checked") == true)&&(jQuery('#edit_folder_recycle').prop("disabled") == false)) {
  //	var recycle = 2;
  //}
  if ((jQuery('#edit_folder_recycle').prop("checked") == true) && (jQuery('#edit_folder_recycle').prop("disabled") == false)) {
    var recycle = 1;
  } else {
    var recycle = 0;
  }


  var user = {};

  if (!jQuery('input[name="edit_folder_radio_permission"]').prop("checked")) {
    var user_check = {};
    var group_check = {};
    jQuery('input[name=' + 'user_ro]:checked').each(function() {
      user[jQuery(this).val()] = 4;
      user_check[jQuery(this).val()] = 4;
    });
    jQuery('input[name=' + 'user_rw]:checked').each(function() {
      user[jQuery(this).val()] = 2;
      user_check[jQuery(this).val()] = 2;
    });
    jQuery('input[name=' + 'user_no]:checked').each(function() {
      user[jQuery(this).val()] = 0;
      user_check[jQuery(this).val()] = 0;
    });

    jQuery('input[name=' + 'group_ro]:checked').each(function() {
      user['@' + jQuery(this).val()] = 4;
      group_check[jQuery(this).val()] = 4;
    });
    jQuery('input[name=' + 'group_rw]:checked').each(function() {
      user['@' + jQuery(this).val()] = 2;
      group_check[jQuery(this).val()] = 2;
    });
    jQuery('input[name=' + 'group_no]:checked').each(function() {
      user['@' + jQuery(this).val()] = 0;
      group_check[jQuery(this).val()] = 0;
    });

    if (jQuery.isEmptyObject(user_check)) {
      //说明一个都没有选
      jQuery('input[name=' + 'user_no]').each(function() {
        user[jQuery(this).val()] = 99; //代表未选
      });
    }

    if (jQuery.isEmptyObject(group_check)) {
      //说明一个都没有选
      jQuery('input[name=' + 'group_no]').each(function() {
        user['@' + jQuery(this).val()] = 99; //代表未选
      });
    }

  }

  var worm = jQuery('#jv-enableworm').prop('checked') ? 1 : 0;
  var graceperiod = 0;
  if (worm) {
    graceperiod = jQuery('#jv-gp-s').val() || 300;
  }

  var smbdata = {
    "action": dirtype,
    "sharename": sharename,
    "path": currP,
    "oldpath": oldP,
    "browseable": browse,
    "recycle": recycle,
    "users": user,
    worm : worm,
    graceperiod : +graceperiod
  }
  if (jQuery('#edit_folder_public').prop("checked") == true) {
    delete smbdata.users;
  }


  var ftpdirtype = "";
  if (jQuery('#edit_folder_ftp_dirtype0').prop("checked") == true)
    ftpdirtype = jQuery('#edit_folder_ftp_dirtype0').val();
  if (jQuery('#edit_folder_ftp_dirtype1').prop("checked") == true)
    ftpdirtype = jQuery('#edit_folder_ftp_dirtype1').val();

  var ftpalias = jQuery.trim(jQuery("#edit_folder_ftp_sharename").val() ? jQuery("#edit_folder_ftp_sharename").val() : folder);
  if (ftpdirtype == "share" && ftpalias == "") {
    alert(window.top.UNAS._("FTP Share Name can not be empty!"));

    return false;
  }

  var ftppermission = "perm";
  if ((jQuery('#edit_folder_ftp_public').prop("checked") == true) && (jQuery('#edit_folder_ftp_public').prop("disabled") == false)) {
    ftppermission = "public";
  }

  var ftpuser = "";
  jQuery('input[name=' + 'ftp_user_ro]:checked').each(function() {
    ftpuser += 'user:' + jQuery(this).val() + ":ro,";
  });
  jQuery('input[name=' + 'ftp_user_rw]:checked').each(function() {
    ftpuser += 'user:' + jQuery(this).val() + ":rw,";
  });

  jQuery('input[name=' + 'ftp_group_ro]:checked').each(function() {
    ftpuser += 'group:' + jQuery(this).val() + ":ro,";
  });
  jQuery('input[name=' + 'ftp_group_rw]:checked').each(function() {
    ftpuser += 'group:' + jQuery(this).val() + ":rw,";
  });
  var ftpdata;
  ftpdata = {
    "share": 1,
    "path": currP,
    "oldpath": oldP,
    "dirtype": ftpdirtype,
    "alias": ftpalias,
    "permission": ftppermission,
    "privilege": ftpuser
  }
  if (jQuery('#edit_folder_ftp_dirtype1').prop("checked") == true) {
    ftpdata.share = 0;
  }


  //webdav
  //webdavdirtype (share, leaf)
  var webdavdirtype = "leaf";
  if (jQuery('#edit_folder_webdav_dirtype0').prop("checked") == true) {
    webdavdirtype = jQuery('#edit_folder_webdav_dirtype0').val(); //share
  }
  if (jQuery('#edit_folder_webdav_dirtype1').prop("checked") == true) {
    webdavdirtype = jQuery('#edit_folder_webdav_dirtype1').val(); //leaf
  }
  //webdavformat (0,1)
  //sharename
  var webdavalias = jQuery.trim(jQuery("#edit_folder_webdav_sharename").val() ? jQuery("#edit_folder_webdav_sharename").val() : folder);
  //path,
  //webdavpermission (0,1)

  //user
  var webdavpermission = "private";
  if ((jQuery('#edit_folder_webdav_public').prop("checked") == true) && (jQuery('#edit_folder_webdav_public').prop("disabled") == false)) { //逻辑上，只需要判断是否勾选
    webdavpermission = "public";
  }

  var webdavuser = {};
  if (webdavpermission == "private") { //public 不需要记录权限
    jQuery('input[name=' + 'webdav_user_ro]:checked').each(function() {
      webdavuser[jQuery(this).val()] = 4;
    });
    jQuery('input[name=' + 'webdav_user_rw]:checked').each(function() {
      webdavuser[jQuery(this).val()] = 2;
    });
  }

  var webdavdata;
  if (jQuery('#edit_folder_webdav_dirtype0').prop("checked") == true) { //共享
    webdavdata = {
      "dirtype": webdavdirtype, //share
      "alias": webdavalias,
      "path": currP, // 没有此项，表示关闭 webdav    XXX这个逻辑不对!!!!!!!!
      "oldpath": oldP,
      "permission": webdavpermission, //public, private
      "users": webdavuser
    }
  } else { //不共享，实际只需要路径和共享名, 和不共享（leaf）
    webdavdata = {
      "dirtype": webdavdirtype,
      "alias": webdavalias,
      "path": currP,
      "oldpath": oldP,
      "users": webdavuser
    }
  }

  //u-file explorer
  var fileexplorerdirtype = "leaf";
  if (jQuery('#edit_folder_fileexplorer_dirtype0').prop("checked") == true)
    fileexplorerdirtype = jQuery('#edit_folder_fileexplorer_dirtype0').val();
  if (jQuery('#edit_folder_fileexplorer_dirtype1').prop("checked") == true)
    fileexplorerdirtype = jQuery('#edit_folder_fileexplorer_dirtype1').val();

  var fileexplorerpermission = "privileged";

  var fileexploreruser = {};
  if ((jQuery('#edit_folder_fileexplorer_public').prop("checked") == true) && (jQuery('#edit_folder_fileexplorer_public').prop("disabled") == false)) { //公共共享 （必须： 共享为 是
    fileexplorerpermission = "public";
  } else {

    jQuery('input[name=' + 'fileexplorer_user_ro]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 4;
    });
    jQuery('input[name=' + 'fileexplorer_user_rw]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 2;
    });
    jQuery('input[name=' + 'fileexplorer_user_no]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 0;
    });
    jQuery('input[name=' + 'fileexplorer_group_ro]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 4;
    });
    jQuery('input[name=' + 'fileexplorer_group_rw]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 2;
    });
    jQuery('input[name=' + 'fileexplorer_group_no]:checked').each(function() {
      fileexploreruser[jQuery(this).val()] = 0;
    });

  }


  var fileexplorerdata;
  if (jQuery('#edit_folder_fileexplorer_dirtype0').prop("checked") == true) {
    fileexplorerdata = { //共享
      "share": 'yes',
      "path": currP,
      "oldpath": oldP,
      "permission": fileexplorerpermission,
      "users": fileexploreruser
    }
  } else { //不共享，
    fileexplorerdata = {
      "share": 'no',
      "path": currP,
      "oldpath": oldP,
      "users": fileexploreruser
    }
  }

  //wanyoucloud
  var wanyouclouddirtype = "leaf";
  if (jQuery('#edit_folder_wanyoucloud_dirtype0').prop("checked") == true)
    wanyouclouddirtype = jQuery('#edit_folder_wanyoucloud_dirtype0').val();
  if (jQuery('#edit_folder_wanyoucloud_dirtype1').prop("checked") == true)
    wanyouclouddirtype = jQuery('#edit_folder_wanyoucloud_dirtype1').val();

  var wanyoucloudalias = jQuery.trim(jQuery("#edit_folder_wanyoucloud_sharename").val() ? jQuery("#edit_folder_wanyoucloud_sharename").val() : folder);

  var wanyoucloudpermission = "privileged";

  if ((jQuery('#edit_folder_wanyoucloud_public').prop("checked") == true) && (jQuery('#edit_folder_wanyoucloud_public').prop("disabled") == false)) { //公共共享 （必须： 共享为 是
    wanyoucloudpermission = "public";
  }

  var wanyouclouddata;
  if (jQuery('#edit_folder_wanyoucloud_dirtype0').prop("checked") == true) {
    wanyouclouddata = { //共享
      "share": 'yes',
      "alias": wanyoucloudalias,
      "path": currP,
      "oldpath": oldP,
      "permission": wanyoucloudpermission,
      "users": wanyoucloudAcl
    }
  } else { //不共享，
    wanyouclouddata = {
      "share": 'no',
      "alias": wanyoucloudalias,
      "path": currP,
      "oldpath": oldP,
      "users": wanyoucloudAcl
    }
  }

  //AFP
  var afpdirtype = "";
  if (jQuery('#edit_folder_afp_dirtype0').prop("checked") == true)
    afpdirtype = jQuery('#edit_folder_afp_dirtype0').val();
  if (jQuery('#edit_folder_afp_dirtype1').prop("checked") == true)
    afpdirtype = jQuery('#edit_folder_afp_dirtype1').val();

  var afpuser = {};
  var afppermission = "";
  if (afpdirtype == "share") {
    if ((jQuery('#edit_folder_afp_public').prop("checked") == true) && (jQuery('#edit_folder_afp_public').prop("disabled") == false)) { //公共共享，不需要user 权限表
      afppermission = "public";
      //delete afpdata.users;
    } else { //权限共享， 提供用户和组权限 表
      afppermission = "private";
      jQuery('input[name=' + 'afp_user_ro]:checked').each(function() {
        // afpuser += 'user:'+jQuery(this).val()+":ro,";
        afpuser[jQuery(this).val()] = 4;
      });
      jQuery('input[name=' + 'afp_user_rw]:checked').each(function() {
        // afpuser += 'user:'+jQuery(this).val()+":rw,";
        afpuser[jQuery(this).val()] = 2;
      });

      jQuery('input[name=' + 'afp_group_ro]:checked').each(function() {
        // afpuser += 'group:'+jQuery(this).val()+":ro,";
        afpuser[jQuery(this).val()] = 4;
      });
      jQuery('input[name=' + 'afp_group_rw]:checked').each(function() {
        // afpuser += 'group:'+jQuery(this).val()+":rw,";
        afpuser[jQuery(this).val()] = 2;
      });

    }
  }

  if (jQuery('#edit_folder_afp_dirtype0').prop("checked") == true) { //共享
    afpdata = {
      "dirtype": 'share', // shared folder
      "sharename": sharename,
      "path": currP,
      "oldpath": oldP,
      "permission": afppermission,
      "users": afpuser
    }
  } else {
    afpdata = { //不共享
      "dirtype": 'leaf', //not shared,
      "path": currP,
      "oldpath": oldP,
      "permission": afppermission, //not needed.
      "users": afpuser
    }
  }


  var note = jQuery('#jv-editshareddescribe').val();
  var sendData = {
    "token": UToken,
    "cmd": "sharedfolder_change",
    "params": {
      "vg": vg,
      "lv": lv,
      "note" : note,
      "path": currP,
      "name": folder.trim(),
      "oldname": oldfolder,
      "samba": smbdata,
      "ftp": ftpdata,
      "webdav": webdavdata,
      "afp": afpdata,
      // "nfs": {
      // 	"path": currP,
      // 	"oldpath": oldP,
      // },
      "fileexplorer": fileexplorerdata,
      "wanyoucloud": wanyouclouddata
    }
  }
  showWaiting();
  jQuery.ajax({
    url: "/apps/shared-folder/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify(sendData),
    contentType: "application/json;",
    dataType: "json",
    success: function(data) {
      showWaiting();
      var w = window.top.UNAS.GetWindow('EditSharedFolderWindow');
      w.ProcessEditSharedFolder();
      MUI.closeWindow(parent.document.getElementById('EditSharedFolderWindow'));
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);
      hideWaiting();
    }
  });
}

function setAcl(type, name, acl) {
  if (jQuery('#edit_folder_wanyoucloud_account_type').val() == type) {
    if (type == 'user') {
      wanyoucloudAcl[name] = acl;
      jQuery('input[name=wanyoucloud_user_rw][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_user_ro][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_user_no][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_user_cu][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_user_all][value=' + name + ']').prop("checked", false);
      if (acl == 'CoxrtncwaTNDd') {
        jQuery('input[name=wanyoucloud_user_all][value=' + name + ']').prop("checked", true);
      } else if (acl == 'xrtncwaTNDd') {
        jQuery('input[name=wanyoucloud_user_rw][value=' + name + ']').prop("checked", true);
      } else if (acl == 'xrtnc') {
        jQuery('input[name=wanyoucloud_user_ro][value=' + name + ']').prop("checked", true);
      } else if (acl == '') {
        jQuery('input[name=wanyoucloud_user_no][value=' + name + ']').prop("checked", true);
      } else {
        jQuery('input[name=wanyoucloud_user_cu][value=' + name + ']').prop("checked", true);
      }
    } else {
      name = '\\\@' + name;
      wanyoucloudAcl[name] = acl;
      jQuery('input[name=wanyoucloud_group_rw][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_group_ro][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_group_no][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_group_cu][value=' + name + ']').prop("checked", false);
      jQuery('input[name=wanyoucloud_group_all][value=' + name + ']').prop("checked", false);
      if (acl == 'CoxrtncwaTNDd') {
        jQuery('input[name=wanyoucloud_group_all][value=' + name + ']').prop("checked", true);
      } else if (acl == 'xrtncwaTNDd') {
        jQuery('input[name=wanyoucloud_group_rw][value=' + name + ']').prop("checked", true);
      } else if (acl == 'xrtnc') {
        jQuery('input[name=wanyoucloud_group_ro][value=' + name + ']').prop("checked", true);
      } else if (acl == '') {
        jQuery('input[name=wanyoucloud_group_no][value=' + name + ']').prop("checked", true);
      } else {
        jQuery('input[name=wanyoucloud_group_cu][value=' + name + ']').prop("checked", true);
      }
    }
  }
}

function EditAclWindowFun(type, name, acl) {
  var typeName = type == 'user' ? UNAS._('User') : UNAS._('User Group');
  var hasSet = false;
  var EditAclW = new MUI.Modal({
    id: 'EditAclWindow',
    title: UNAS._('Edit ACL') + " " + SharedFolderCutStr(jQuery('#edit_folder_name').val() + " " + typeName + ":" + name, 60),
    modal: true,
    modalOverlayClose: false,
    width: 600,
    height: 350,
    contentURL: '/apps/shared-folder/edit_acl.html?v=6.0.71&type=' + type + '&name=' + name + '&acl=' + acl,
    onClose: function() {
      if (!hasSet) {
        setAcl(type, name, acl);
      }
    },
  });
  EditAclW.setAcl = function(type, name, acl) {
    hasSet = true;
    setAcl(type, name, acl);
  };
}

function switchpermoption(pnode) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var type = that.attr('type');
  that.addClass('cur-nav').siblings().removeClass('cur-nav');
  jQuery('#' + pnode).find('.jvc-pageset').hide();
  jQuery('#' + pnode).find('.jvc-' + type + '-set').show();
}

function deleteallhistoricalV() {
  unasConfirmSF({}, function() {});
}

function submit_editSharedFolder_acl() {
  var new_sddl = 'O:' + jQuery('#jv-editacl_owner_val').attr('value');
  new_sddl += 'G:' + jQuery('#jv-editacl_group_val').attr('value');
  new_sddl += 'D:';
  var inherit = jQuery('#jv_editinherit')[0].checked;
  if (inherit) {
    new_sddl += "AI";
  } else {
    new_sddl += "PAI";
  }
  // (A;OICI;权限;;;id)
  jQuery('#jv-sddltable_content tr').each(function(i, e) {
    var ck = jQuery(e).find('input[type=checkbox]');
    for (var j = 0; j < ck.length; j++) {
      var id = jQuery(ck[j]).closest('tr.trp').attr('id');
      var ace = jQuery(ck[j]).closest('tr.trp').attr('ace');
      if (ck[j].checked) {
        if (jQuery(ck[j]).val()) {
          if (jQuery(ck[j]).attr('name') == 'custom' && ace) {
            new_sddl += (ace || '(A;OICI;' + jQuery(ck[j]).val() + ';;;' + id + ')');
          }else {
            new_sddl += '(A;OICI;' + jQuery(ck[j]).val() + ';;;' + id + ')';
          }
        }else {
          if (jQuery(ck[j]).attr('name') == 'sddl_user_no') {
            new_sddl += '(D;OICI;0x001f01ff;;;' + id + ')';
          }else if(ace){
            new_sddl += ace;
          }
        }
      }
    }
  })
  if (sddl_not) {
    new_sddl += sddl_not;
  }
  var folder = jQuery('#edit_folder_oldname').val();
  var path = jQuery('#edit_folder_path').val() + "/" + folder;

  data = {
    cmd: "acl_setsddl",
    token: UToken,
    params: {
      sddl: new_sddl,
      path: path,
      chown: 0,
      lazy : 1,
      force_cover: 0
    }
  }
  showWaiting();
  jQuery.ajax({
    url: "/api/acl/index.php",
    type: "POST",
    async: true,
    timeout: 20000,
    dataType: "json",
    contentType: "json",
    data: JSON.encode(data),
    success: function(data) {
      var errmsg = {
        9988: 'Permission denied',
        9994: 'Not exists',
        9895: 'Partly succeed. Failed to set some child items.',
        9999: 'Failed to set ACL'
      }

      if (data.err == 0) {
        setTimeout(function(){
          getPermission();
          hideWaiting();
        }, 1000);
      } else {
        alert(errmsg[data.err]);
        hideWaiting();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

(function() {
  var DISABLED = 0;
  var ENABLED = 1;
  //设置table滚动条
  jQuery("#shared_folder_samba_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#jv-showuser-sddl-h").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery("#shared_folder_ftp_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#shared_folder_webdav_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#shared_folder_afp_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#shared_folder_nfs_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#shared_folder_fileexplorer_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#shared_folder_wanyoucloud_edit_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  jQuery('.editnavitem').click(function() {
    var type = jQuery(this).attr('type');
    jQuery(this).addClass('cur-editnavitem').siblings().removeClass('cur-editnavitem');
    jQuery('#' + type).show().siblings().hide();

    if (type == "edit_folder_nfsoption") {
      //点击'NFS 权限'时，隐藏底部按钮
      getFolderNFS();
      jQuery('#shared_folder_editfolder_submit_div').attr('style', 'display:none');
    } else {
      jQuery('#shared_folder_editfolder_submit_div').attr('style', 'display:block');
    }
  });

  jQuery('#edit_folder_location').val(fullfolder);
  jQuery('#edit_folder_location').attr("title", fullfolder);
  jQuery('#edit_folder_location').html(SharedFolderCutStr(fullfolder, 80));
  jQuery('#edit_folder_name').val(folder);
  if (name_editable == DISABLED) {
    jQuery('#edit_folder_name').attr("disabled", true);
  }
  //
  jQuery('#jv-editshareddescribe').val(note);
  jQuery('#edit_folder_oldname').val(folder);

  jQuery('#edit_folder_path').val(volumemountpoint);
  jQuery('#edit_folder_vg').val(vg);
  jQuery('#edit_folder_lv').val(lv);
  jQuery('#edit_folder_devpath').val(volumepath);

  getEditFolderInfo();

  getFolderNFS();

  getPermission();

  jQuery('#jv-enableworm').on('click', function(){
    if (this.checked) {
      jQuery('#jv-gpsitem').show();
    }else {
      jQuery('#jv-gpsitem').hide();
    }
  })

})();
